;***************************************************************************
;                Home Entertainment System 1201 - Firmware
;***************************************************************************
;
; File Name			:'cs42528.asm"
; Title				: cs42528 Codec Manager
; Date		    	: 05.06.2005
; Version		    : 0.1.0
; Homepage			: www.pingpong.homepage.t-online.de
; Support telephone	: +49 681 8317950 Alwin Esch
; Support fax		: +49 681 8319536 Alwin Esch
; Support Email		: hes1201@medianet2000.fli4l.net
; Target MCU		: ATmega128
;
;***************************************************************************
;	D E S C R I P T I O N
;
;	Controls the Cirrus Logic CS42528 8 Channel Audicodec
;	
;	
;***************************************************************************
;	P U B L I C   F U N C T I O N S
;	
;	Init_DSP_BOARD
;	Powerup_DSP_BOARD
;	GetDSPBoardPPMode
;	SetDSPBoardPPMode
;	GetDSPBoardOPMode
;	SetDSPBoardOPMode
;	GetBoardInputMode
;	SetBoardInputMode
;	GetVolumeTransition
;	SetVolumeTransition
;	GetVolume_TOTAL
;	SetVolume_TOTAL
;	GetVolume_LEFT
;	SetVolume_LEFT
;	GetVolume_RIGHT
;	SetVolume_RIGHT
;	GetVolume_CENTER
;	SetVolume_CENTER
;	GetVolume_SUBWOOFER
;	SetVolume_SUBWOOFER
;	GetVolume_LEFT_SURR
;	SetVolume_LEFT_SURR
;	GetVolume_RIGHT_SURR
;	SetVolume_RIGHT_SURR
;	GetVolume_LEFT_ZONE
;	SetVolume_LEFT_ZONE
;	GetVolume_RIGHT_ZONE
;	SetVolume_RIGHT_ZONE
;	GetMute_ALL
;	SetMute_ALL
;	GetMute_LEFT
;	SetMute_LEFT
;	GetMute_RIGHT
;	SetMute_RIGHT
;	GetMute_CENTER
;	SetMute_CENTER
;	GetMute_SUBWOOFER
;	SetMute_SUBWOOFER
;	GetMute_LEFT_SURR
;	SetMute_LEFT_SURR
;	GetMute_RIGHT_SURR
;	SetMute_RIGHT_SURR
;	GetMute_LEFT_ZONE
;	SetMute_LEFT_ZONE
;	GetMute_RIGHT_ZONE
;	SetMute_RIGHT_ZONE
;	GetMute_SPDIF
;	SetMute_SPDIF
;	GetSPDIF_Input
;	SetSPDIF_Input
;	GetSPDIF_Output
;	SetSPDIF_Output
;
;***************************************************************************
;	M O D I F I C A T I O N   H I S T O R Y
;
;
;   rev.       date         who  		why
;	----	----------  -----------		--------------------------------------------
;	0.10	05.06.2005  Alwin Esch		Creation
;
;***************************************************************************

;***************************************************************************
;Hardware
;***************************************************************************
;*
;*	SYSCLK: f=16.000 MHz (T= 62.5 ns)
;*
;***************************************************************************

;**************************************************************************
;* Hardware Def.
;PORTA
.equ	SPDIF_TX_RESET	= 0
.equ	CODEC_RESET		= 1
.equ	DSP_2_RESET		= 2
.equ	DSP_1_RESET		= 3
.equ	SPDIF_TX_CS		= 4
.equ	CODEC_CS		= 5
.equ	DSP_2_CS		= 6
.equ	DSP_1_CS		= 7

;PORTF
.equ	DSP1_Pagebit0	= 0
.equ	DSP1_Pagebit1	= 1
.equ	DSP1_Pagebit2	= 2
.equ	DSP1_Pagebit3	= 3
.equ	DSP2_Pagebit0	= 4
.equ	DSP2_Pagebit1	= 5
.equ	DSP2_Pagebit2	= 6
.equ	DSP2_Pagebit3	= 7

;PORTE
.equ	SPDIF_TX_IRQ	= 7		; PINE
.equ	CODEC_IRQ		= 6
.equ	DSP1_IRQ		= 5
.equ	DSP1_AUTOBOOT	= 5
.equ	DSP2_IRQ		= 4
.equ	DSP2_AUTOBOOT	= 4
.equ	DSPAudioSel		= 3
.equ	ExtDSPAudioSel	= 2

;PORTG
.equ	DSP_FLASH_SEL	= 0
.equ	DSP_SRAM_SEL	= 1


;***************************************************************************
;* Const Def

.equ	CODEC_HW_ADR				= 0b10011110
.equ	  CODEC_READ				  = 0b00000001
.equ	  CODEC_WRITE				  = 0b00000000
.equ		CODEC_ADR_ChipID			= $01
.equ		CODEC_ADR_PowerControl		= $02
.equ		  COD_FL__PDN__Default	 		= 0b00000000
.equ		  COD_FL__PDN_RCVR	 			= 0b11000000
.equ		  COD_FL__PDN_RCVR1 			= 0b10000000
.equ		  COD_FL__PDN_RCVR0				= 0b01000000
.equ		  COD_FL__PDN_ADC				= 0b00100000
.equ		  COD_FL__PDN_DAC4	 			= 0b00010000
.equ		  COD_FL__PDN_DAC3				= 0b00001000
.equ		  COD_FL__PDN_DAC2				= 0b00000100
.equ		  COD_FL__PDN_DAC1	 			= 0b00000010
.equ		  COD_FL__PDN					= 0b00000001
.equ		CODEC_ADR_FunctionalMode	= $03
.equ		  COD_FL__FuncMode__Default	 	= 0b10100100
.equ		  COD_FL__FuncMode__CODEC_FM1 	= 0b10000000
.equ		  COD_FL__FuncMode__CODEC_FM0 	= 0b01000000
.equ		  COD_FL__FuncMode__SAI_FM1 	= 0b00100000
.equ		  COD_FL__FuncMode__SAI_FM0 	= 0b00010000
.equ		  COD_FL__FuncMode__ADC_SP_SEL1	= 0b00001000
.equ		  COD_FL__FuncMode__ADC_SP_SEL0	= 0b00000100
.equ		  COD_FL__FuncMode__DAC_DEM 	= 0b00000010
.equ		  COD_FL__FuncMode__RCVR_DEM	= 0b00000001
.equ		CODEC_ADR_InterfaceFormats	= $04
.equ		  COD_FL__InterfForm__Default	= 0b00000000
.equ		  COD_FL__InterfForm_DIF1  		= 0b10000000
.equ		  COD_FL__InterfForm_DIF0  		= 0b01000000
.equ		  COD_FL__InterfForm_ADC_OL1 	= 0b00100000
.equ		  COD_FL__InterfForm_ADC_OL0 	= 0b00010000
.equ		  COD_FL__InterfForm_DAC_OL1 	= 0b00001000
.equ		  COD_FL__InterfForm_DAC_OL0 	= 0b00000100
.equ		  COD_FL__InterfForm_SAI_RJ16 	= 0b00000010
.equ		  COD_FL__InterfForm_CODEC_RJ16	= 0b00000001
.equ		CODEC_ADR_MiscControl		= $05
.equ		  COD_FL__MiscControl__Def	 		= 0b10000001
.equ		  COD_FL__MiscControl_ExtADC_SCLK	= 0b10000000
.equ		  COD_FL__MiscControl_HiZ_RMCK		= 0b01000000
.equ		  COD_FL__MiscControl_Reserved		= 0b00100000
.equ		  COD_FL__MiscControl_FREEZE		= 0b00010000
.equ		  COD_FL__MiscControl_FILT_SEL		= 0b00001000
.equ		  COD_FL__MiscControl_HPF_FREEZE	= 0b00000100
.equ		  COD_FL__MiscControl_CODEC_SP_MS	= 0b00000010
.equ		  COD_FL__MiscControl_SAI_SP_MS		= 0b00000001
.equ		CODEC_ADR_ClockControl		= $06
.equ		  COD_FL__ClockContr__Default		= 0b00000110
.equ		  COD_FL__ClockContr__RMCK_DIV1		= 0b10000000
.equ		  COD_FL__ClockContr__RMCK_DIV0		= 0b01000000
.equ		  COD_FL__ClockContr__OMCKFreq1		= 0b00100000
.equ		  COD_FL__ClockContr__OMCKFreq0		= 0b00010000
.equ		  COD_FL__ClockContr__PLL_LRCK		= 0b00001000
.equ		  COD_FL__ClockContr__SW_CTRL1		= 0b00000100
.equ		  COD_FL__ClockContr__SW_CTRL0 		= 0b00000010
.equ		  COD_FL__ClockContr__FRC_PLL_LK	= 0b00000001
.equ		CODEC_ADR_OMCK__PLLCLKRatio	= $07
.equ		CODEC_ADR_OMCK__RVCRStatus	= $08
.equ		CODEC_ADR_BurstPreamblePCByte0	= $09
.equ		CODEC_ADR_BurstPreamblePCByte1	= $0A
.equ		CODEC_ADR_BurstPreamblePDByte0	= $0B
.equ		CODEC_ADR_BurstPreamblePDByte1	= $0C
.equ		CODEC_ADR_VolumeControl		= $0D
.equ		  COD_FL__VolumeControl__Def	= 0b00101000
.equ		  COD_FL__VolumeControl_SNGVOL 	= 0b01000000
.equ		  COD_FL__VolumeControl_SZC1 	= 0b00100000
.equ		  COD_FL__VolumeControl_SZC0 	= 0b00010000
.equ		  COD_FL__VolumeControl_AMUTE 	= 0b00001000
.equ		  COD_FL__VolumeControl_MUTE_SAI_SP 	= 0b00000100
.equ		  COD_FL__VolumeControl_RAMP_UP	= 0b00000010
.equ		  COD_FL__VolumeControl_RAMP_DN	= 0b00000001
.equ		CODEC_ADR_ChannelMute		= $0E
.equ		  COD_FL__ChannelMute__Def	 	= 0b00000000
.equ		  COD_FL__ChannelMute_B4_MUTE 	= 0b10000000
.equ		  COD_FL__ChannelMute_A4_MUTE 	= 0b01000000
.equ		  COD_FL__ChannelMute_B3_MUTE 	= 0b00100000
.equ		  COD_FL__ChannelMute_A3_MUTE 	= 0b00010000
.equ		  COD_FL__ChannelMute_B2_MUTE 	= 0b00001000
.equ		  COD_FL__ChannelMute_A2_MUTE 	= 0b00000100
.equ		  COD_FL__ChannelMute_B1_MUTE 	= 0b00000010
.equ		  COD_FL__ChannelMute_A1_MUTE	= 0b00000001
.equ		CODEC_ADR_VolControlA1		= $0F
.equ		CODEC_ADR_VolControlB1		= $10
.equ		CODEC_ADR_VolControlA2		= $11
.equ		CODEC_ADR_VolControlB2		= $12
.equ		CODEC_ADR_VolControlA3		= $13
.equ		CODEC_ADR_VolControlB3		= $14
.equ		CODEC_ADR_VolControlA4		= $15
.equ		CODEC_ADR_VolControlB4		= $16
.equ		CODEC_ADR_ChannelInvert		= $17
.equ		  COD_FL__ChannelInvert__Def	= 0b00000000
.equ		CODEC_ADR_MixingCtrlPair1	= $18
.equ		CODEC_ADR_MixingCtrlPair2	= $19
.equ		CODEC_ADR_MixingCtrlPair3	= $1A
.equ		CODEC_ADR_MixingCtrlPair4	= $1B
.equ		CODEC_ADR_ADCLeftChGain		= $1C
.equ		CODEC_ADR_ADCRightChGain	= $1D
.equ		CODEC_ADR_RCVRModeCtrl		= $1E
.equ		  COD_FL__RCVRMdCtrl__Def		= 0b00110100
.equ		  COD_FL__RCVRMdCtrl_SP_SYNC 	= 0b10000000
.equ		  COD_FL__RCVRMdCtrl_Reserved 	= 0b01000000
.equ		  COD_FL__RCVRMdCtrl_DE_EMPH1 	= 0b00100000
.equ		  COD_FL__RCVRMdCtrl_DE_EMPH0 	= 0b00010000
.equ		  COD_FL__RCVRMdCtrl_INT1 		= 0b00001000
.equ		  COD_FL__RCVRMdCtrl_INT0 		= 0b00000100
.equ		  COD_FL__RCVRMdCtrl_HOLD1 		= 0b00000010
.equ		  COD_FL__RCVRMdCtrl_HOLD0		= 0b00000001
.equ		CODEC_ADR_RCVRModeCtrl2		= $1F
.equ		  COD_FL__RCVRModeCtrl2__Def	= 0b00000000
.equ		CODEC_ADR_InterruptStatus	= $20
.equ		CODEC_ADR_InterruptMask		= $21
.equ		  COD_FL__InterruptMask__Def	= 0b10111011
.equ		  COD_FL__InterruptMask_UNLOCKM	= 0b10000000
.equ		  COD_FL__InterruptMask_QCHM 	= 0b00100000
.equ		  COD_FL__InterruptMask_DETCM 	= 0b00010000
.equ		  COD_FL__InterruptMask_DETUM 	= 0b00001000
.equ		  COD_FL__InterruptMask_OverFlM = 0b00000010
.equ		  COD_FL__InterruptMask_RERRM	= 0b00000001
.equ		CODEC_ADR_InterruptModeMSB	= $22
.equ		  COD_FL__InterruptModeMSB__Def	= 0b00000000
.equ		CODEC_ADR_InterruptModeLSB	= $23
.equ		  COD_FL__InterruptModeLSB__Def	= 0b10111011
.equ		CODEC_ADR_BufferCtrl		= $24
.equ		CODEC_ADR_RCVRCSData		= $25
.equ		CODEC_ADR_RCVRErrors		= $26
.equ		CODEC_ADR_RCVRErrorsMask	= $27
.equ		CODEC_ADR_MUTEC				= $28
.equ		  COD_FL__MUTEC__Def			= 0b00000000
.equ		  COD_FL__MUTEC__MUTE			= 0b00100000
.equ		CODEC_ADR_RXP7__GPO7		= $29
.equ		CODEC_ADR_RXP6__GPO6		= $2A
.equ		CODEC_ADR_RXP5__GPO5		= $2B
.equ		CODEC_ADR_RXP4__GPO4		= $2C
.equ		CODEC_ADR_RXP3__GPO3		= $2D
.equ		CODEC_ADR_RXP2__GPO2		= $2E
.equ		CODEC_ADR_RXP1__GPO1		= $2F
;

.equ	SPDIF_TX_HW_ADR				= 0b00100000
.equ	  SPDIF_TX_READ				  = 0b00000001
.equ	  SPDIF_TX_WRITE			  = 0b00000000
.equ	    SPDIF_TX_ADR_Control1		= $01
.equ		  SPDIF_FL_Control1__Def		= 0b01000011
.equ		  SPDIF_FL__VSET				= 0b01000000
.equ		  SPDIF_FL__MUTEAES		 		= 0b00010000
.equ		  SPDIF_FL__INT1				= 0b00000100
.equ		  SPDIF_FL__INT0				= 0b00000010
.equ		  SPDIF_FL__TCBLD				= 0b00000001
.equ	    SPDIF_TX_ADR_Control2		= $02
.equ		  SPDIF_FL_Control2__Def		= 0b00000000
.equ		  SPDIF_FL__MMT					= 0b00000100
.equ		  SPDIF_FL__MMCST				= 0b00000010
.equ		  SPDIF_FL__MMTLR				= 0b00000001
.equ	    SPDIF_TX_ADR_DataFlowCtrl	= $03
.equ		  SPDIF_FL_DataFlowCtrl__Def	= 0b00100000
.equ		  SPDIF_FL__TXOFF				= 0b01000000
.equ		  SPDIF_FL__AESBP				= 0b00100000
.equ	    SPDIF_TX_ADR_ClockSrcCont	= $04
.equ		  SPDIF_FL__RUN					= 0b01000000
.equ		  SPDIF_FL__CLK1				= 0b00100000
.equ		  SPDIF_FL__CLK0		 		= 0b00010000
.equ	    SPDIF_TX_ADR_SerInputFormat	= $05
.equ		  SPDIF_FL_SerInputFormat__Def	= 0b00000000
.equ		  SPDIF_FL__SIMS				= 0b10000000
.equ		  SPDIF_FL__SISF				= 0b01000000
.equ		  SPDIF_FL__SIRES1				= 0b00100000
.equ		  SPDIF_FL__SIRES0		 		= 0b00010000
.equ		  SPDIF_FL__SIJUST				= 0b00001000
.equ		  SPDIF_FL__SIDEL				= 0b00000100
.equ		  SPDIF_FL__SISPOL				= 0b00000010
.equ		  SPDIF_FL__SILRPOL				= 0b00000001
.equ	    SPDIF_TX_ADR_Int1Status	 	 = $07
.equ		  SPDIF_FL__TSLIP		 		= 0b10000000
.equ		  SPDIF_FL__EFTC				= 0b00000010
.equ	    SPDIF_TX_ADR_Int2Status	 	 = $08
.equ		  SPDIF_FL__EFTU				= 0b00000100
.equ	    SPDIF_TX_ADR_Int1Mask	 	 = $09
.equ		  SPDIF_FL_Int1Mask__Def		= 0b10000000
.equ		  SPDIF_FL__TSLIPM		 		= 0b10000000
.equ		  SPDIF_FL__EFTCM				= 0b00000010
.equ	    SPDIF_TX_ADR_Int1ModeMSB	 = $0a
.equ		  SPDIF_FL_Int1ModeMSB__Def		= 0b00000000
.equ		  SPDIF_FL__TSLIP1		 		= 0b10000000
.equ		  SPDIF_FL__EFTC1 				= 0b00000010
.equ	    SPDIF_TX_ADR_Int1ModeLSB	 = $0b
.equ		  SPDIF_FL_Int1ModeLSB__Def		= 0b10000010
.equ		  SPDIF_FL__TSLIP0		 		= 0b10000000
.equ		  SPDIF_FL__EFTC0 				= 0b00000010
.equ	    SPDIF_TX_ADR_Int2Mask		 = $0c
.equ		  SPDIF_FL_Int2Mask__Def		= 0b00000000
.equ		  SPDIF_FL__EFTUM				= 0b00000100
.equ	    SPDIF_TX_ADR_Int2ModeMSB	 = $0d
.equ		  SPDIF_FL_Int2ModeMSB__Def		= 0b00000000
.equ		  SPDIF_FL__EFTU1				= 0b00000100
.equ	    SPDIF_TX_ADR_Int2ModeLSB	 = $0e
.equ		  SPDIF_FL_Int2ModeLSB__Def		= 0b00000100
.equ		  SPDIF_FL__EFTU0				= 0b00000100
.equ	    SPDIF_TX_ADR_CSDataBufferCtrl = $12
.equ		  SPDIF_FL__BSEL 				= 0b00100000
.equ		  SPDIF_FL__EFTCI 				= 0b00000100
.equ		  SPDIF_FL__CAM 				= 0b00000010
.equ	    SPDIF_TX_ADR_UDataBufferCtrl = $13
.equ		  SPDIF_FL_UDataBufferCtrl__Def	= 0b00000000
.equ		  SPDIF_FL__UD 		 			= 0b00010000
.equ		  SPDIF_FL__UBM1 		 		= 0b00001000
.equ		  SPDIF_FL__UBM0		 		= 0b00000100
.equ		  SPDIF_FL__EFTUI		 		= 0b00000001
.equ		SPDIF_TX_ADR_ChipID			= $7f

; DSP Boot Read Msg Mnemonics
.equ		BOOT_START	   				= $01
.equ		BOOT_SUCCESS    = 0x02
.equ		APP_FAIL        = 0xF0
.equ		BOOT_ERROR      = 0xFA
.equ		INVALID_MSG	   = 0xFB
.equ		BOOT_ERROR2     = 0xFC
.equ		INIT_FAILURE	   = 0xFD
.equ		INIT_FAILURE2	= 0xFE
.equ		BAD_CHKSUM	   = 0xFF

; General Audio Mgr. SW Config Variables
.equ		AUDIO_MGR_CTRL	= 0x00
.equ		NOISE_CTRL      = 0x01
.equ		C_DELAY         = 0x02
.equ		PCM_PREC	      = 0x03
.equ		LS_DELAY	      = 0x04
.equ		RS_DELAY        = 0x05
.equ		MASTER_VOL      = 0x06
.equ		L_VOL           = 0x07
.equ		C_VOL           = 0x08
.equ		R_VOL           = 0x09
.equ		LS_VOL		      = 0x0a
.equ		RS_VOL          = 0x0b
.equ		LFE_VOL         = 0x0c
.equ		MUTE		      = 0x0d
.equ		DAO0_CHAN       = 0x0e
.equ		DAO1_CHAN       = 0x0f
.equ		DAO2_CHAN       = 0x10
.equ		DAO3_CHAN	      = 0x11
.equ		DAO4_CHAN	      = 0x12
.equ		DAO5_CHAN	      = 0x13
.equ		SMPL_FREQ_CODE	= 0x14
.equ		PCM_AD_SILENCE 	= 0x15
.equ		LAST_UNSOL_MSG 	= 0x16
.equ		PLL_REG_1 	   = 0x17
.equ		PLL_REG_2  	   = 0x18
.equ		L_DELAY 	      = 0x19
.equ		R_DELAY         = 0x1a
.equ		LFE_DELAY       = 0x1b
.equ		LZ_VOL	         = 0x1c
.equ		RZ_VOL	         = 0x1d
.equ		DAO6_CHAN       = 0x1e
.equ		DAO7_CHAN       = 0x1f
.equ		DUALZONE_ATTN   = 0x20

; AC-3 Specific Audio Mgr. SW Config Variables
.equ		AC3_CTRL	      = 0x00
.equ		OUTPUT_MODE     = 0x01
.equ		COMP_CTRL       = 0x02
.equ		CUT_X           = 0x03
.equ		BOOST_Y         = 0x04
.equ		FSCOD           = 0x05
.equ		BSMOD		      = 0x06
.equ		ACMOD		      = 0x07
.equ		DSURMOD		   = 0x08
.equ		CLEV            = 0x09
.equ		SLEV            = 0x0a
.equ		LFEON           = 0x0b
.equ		DIALNORM        = 0x0c
.equ		COMPR		      = 0x0d
.equ		DIALNORM2       = 0x0e
.equ		COMPR2          = 0x0f
.equ		BSID            = 0x10
.equ		LANGCOD		   = 0x11
.equ		MIXLVL_RMTYPE	= 0x12
.equ		LANGCOD2	      = 0x13
.equ		MIXLVL2_RMTYPE2	= 0x14
.equ		COPYRIGHTB	   = 0x15
.equ		ORIGBS	 	      = 0x16
.equ		FRMSIZCOD	      = 0x17
.equ		TIMECOD 	      = 0x18
.equ		TIMECOD2 	      = 0x19

.equ	DSP1_HW_ADR					= 0b00000000
.equ	  DSP1_READ					  = 0b00000001
.equ	  DSP1_WRITE				  = 0b00000000

.equ	DSP2_HW_ADR					= 0b00000000
.equ	  DSP2_READ					  = 0b00000001
.equ	  DSP2_WRITE				  = 0b00000000

.equ	  DecodeSel_PCM				= 0
.equ	  DecodeSel_PCMProLogic		= 1
.equ	  DecodeSel_AC3				= 2
.equ	  DecodeSel_AC3ProLogic		= 3
.equ	  DecodeSel_DTS				= 4

.equ	  DecodeSel_CrystalDPP		= 0


.equ	  ROMImage1_AC3_PL2_CES		= 0
.equ	  ROMImage1_DTS_CES			= 1
.equ	  ROMImage1_DTS_6DOT1		= 2
.equ	  ROMImage1_DTS_NEO6		= 3
.equ	  ROMImage1_CS2				= 4
.equ	  ROMImage1_EFF				= 5
.equ	  ROMImage1_LG7_7DOT1		= 6
.equ	  ROMImage1_PL2_2FS			= 7
.equ	  ROMImage1_unused			= 8
.equ	  ROMImage1_unused1			= 9
.equ	  ROMImage1_unused2			= 10
.equ	  ROMImage1_unused3			= 11
.equ	  ROMImage1_unused4			= 12
.equ	  ROMImage1_unused5			= 13
.equ	  ROMImage1_unused6			= 14
.equ	  ROMImage1_unused7			= 15
	  
.equ	  ROMImage2_DPP8			= 0
.equ	  ROMImage2_TEXO8_2MB		= 1
.equ	  ROMImage2_unused2			= 2
.equ	  ROMImage2_unused3			= 3
.equ	  ROMImage2_unused4			= 4
.equ	  ROMImage2_unused5			= 5
.equ	  ROMImage2_unused6			= 6
.equ	  ROMImage2_unused7			= 7
.equ	  ROMImage2_unused8			= 8
.equ	  ROMImage2_unused9			= 9
.equ	  ROMImage2_unused10		= 10
.equ	  ROMImage2_unused11		= 11
.equ	  ROMImage2_unused12		= 12
.equ	  ROMImage2_unused13		= 13
.equ	  ROMImage2_unused14		= 14
.equ	  ROMImage2_unused15		= 15

;**************************************************************************
;* Hardware Def.
;
;***************************************************************************
;**** VARIABLES
.DSEG

DSP_ReceiveBuffer:			.BYTE 32

DSPBoardMasterFlags:		.BYTE 1
.equ	DSPBoardMstrFl_FLASH_AVAIL	= 0b00000001
.equ	DSPBoardMstrFl_PROLOGIC		= 0b00000010
.equ	DSPBoardMstrFl_POST_PROC	= 0b00000100
.equ	DSPBoardMstrFl_THX_PROC		= 0b00001000

DSPBoardOperatingMode:		.BYTE 1

DSP_DecodingMode:			.BYTE 1
DSP1_LoadedRom:				.BYTE 1
DSP2_LoadedRom:				.BYTE 1

CS42528Flags_PowerControl:	.BYTE 1
CS42528Flags_FuncMode:		.BYTE 1


; Volumedata
VOLUME_TOTAL:				.BYTE 1
VOLUME_LEFT:				.BYTE 1
VOLUME_RIGHT:				.BYTE 1
VOLUME_CENTER:				.BYTE 1
VOLUME_SUBWOFER:			.BYTE 1
VOLUME_LEFT_SURR:			.BYTE 1
VOLUME_RIGHT_SURR:			.BYTE 1
VOLUME_LEFT_ZONE:			.BYTE 1
VOLUME_RIGHT_ZONE:			.BYTE 1

SPDIF_OUTPUT_SOURCE:		.BYTE 1
SPDIF_INPUT_SOURCE:			.BYTE 1

INDPT_CHANNEL_MUTE:			.BYTE 1


;***************************************************************************
.ESEG


;***************************************************************************
;**** CODE SEG
;***************************************************************************
.CSEG

;***************************************************************************
;* Codec Interrupt
;***************************************************************************
;*
CODEC_INT_Handler:
		reti
;*
;***************************************************************************


;***************************************************************************
;* Transmitter Interrupt
;***************************************************************************
;*
SPDIF_TX_INT_Handler:
		reti
;*
;***************************************************************************


;***************************************************************************
;* DSP1 Interrupt
;***************************************************************************
;*
DSP1_INT_Handler:
		reti
;*
;***************************************************************************


;***************************************************************************
;* DSP1 Interrupt
;***************************************************************************
;*
DSP2_INT_Handler:
		reti
;*
;***************************************************************************

;***************************************************************************
;* DSP Board Initialization
;***************************************************************************
;*
Init_DSP_BOARD:
; Set IO-Pin directions
		ser		al
		out		DDRA, al

		in		al, DDRB
		ori		al, 0b11110000
		out		DDRB, al

		in		al, DDRE
		andi	al, ~0b00110000
		ori		al, 0b00001100
		out		DDRE, al

		ser		al
		sts		DDRF, al

		lds		al, DDRG
		ori		al, 0b00000011
		sts		DDRG, al

; Set output of pins to default
		clr		al
		out		PORTA, al

		in		al, PORTB
		andi	al, ~0b11110000
		out		PORTB, al

		in		al, PORTE
		andi	al, ~0b00001100
		out		PORTE, al

		clr		al
		sts		PORTF, al

		lds		al, PORTG
		andi	al, ~0b00000011
		sts		PORTG, al

; Load default data from EEprom
		ldi		bl, EEPROM_DSP_BOARD_FLAGS_LO
		ldi		bh, EEPROM_DSP_BOARD_FLAGS_HI
		call	EERead	
		sts		DSPBoardMasterFlags, al
		ldi		bl, EEPROM_DSP_BOARD_MODE_LO
		ldi		bh, EEPROM_DSP_BOARD_MODE_HI
		call	EERead	
		sts		DSPBoardOperatingMode, al

; Load default variables
		ldi		al, 255
		sts		VOLUME_TOTAL, al
		sts		DSP_DecodingMode, al
		sts		DSP1_LoadedRom, al
		sts		DSP2_LoadedRom, al
		ldi		al, 0
		sts		VOLUME_LEFT, al
		sts		VOLUME_RIGHT, al
		sts		VOLUME_CENTER, al
		sts		VOLUME_SUBWOFER, al
		sts		VOLUME_LEFT_SURR, al
		sts		VOLUME_RIGHT_SURR, al
		sts		VOLUME_LEFT_ZONE, al
		sts		VOLUME_RIGHT_ZONE, al
		sts		INDPT_CHANNEL_MUTE, al
		sts		CS42528Flags_PowerControl, al
		sts		CS42528Flags_FuncMode, al
		ldi		al, 8
		sts		SPDIF_INPUT_SOURCE, al					; Default to input 8, PC
		sts		SPDIF_OUTPUT_SOURCE, al					; Default to output 8, PC


		ret
;*
;***************************************************************************


;***************************************************************************
;* DSP Board powerup
;***************************************************************************
;*
Powerup_DSP_BOARD:
		in		al, PORTA
		andi	al, ~((1<<SPDIF_TX_RESET)|(1<<CODEC_RESET)|(1<<DSP_2_RESET)|(1<<DSP_1_RESET))
		ori		al, (1<<CODEC_CS)|(1<<SPDIF_TX_CS)|(1<<DSP_1_CS)|(1<<DSP_2_CS)
		out		PORTA, al

		rcall	Init_CS42528
		rcall	Init_CS8406

; Check if Postprocessing is enabled
		lds		al, DSPBoardOperatingMode
		cpi		al, 4
		brne	Powerup_DSP_BOARD_PP				; Jump if Board not in Postprocessingmode (Mode 4)

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_POST_PROC
		brne	Powerup_DSP_BOARD_PP				; Jump if Board Postprocessing bit is set		

		ldi		al, 1								; Force single DSP-Mode (Mode 1) if Postprocessing is disabled

Powerup_DSP_BOARD_PP:
		rcall	Init_DSPs


		ret
;*
;***************************************************************************


;***************************************************************************
;* Check the DSP-Board during runtime for any interrupt conditions and if
;* a condition accours, change mode and application.
;***************************************************************************
;*
Rd_Autodetect_Response_MSG:			.db 0x87,0x00,0x00,0x00,0x00,0x00

.equ	Decodable_Stream_Flag		= 0b10000000
.equ	Non_IEC61937_StreamFlag		= 0b00100000
.equ	DETECT_AC3_Stream			= 0x01
.equ	DETECT_PCMcodedAC3_Stream	= 0x20 ;???????????????!!!!!!!!!!!!!!!!!!
.equ	DETECT_DTS_Stream			= 0x21
.equ	DETECT_LinearPCM_Stream		= 0x23

Check_DSP_BOARD:
; Exists Interrupt condition for DSP 1?
		sbis	PINE, DSP1_IRQ											;
		rjmp	Check_DSP_BOARD_CS49326
; Exists Interrupt condition for DSP 2?
		sbis	PINE, DSP2_IRQ											;
		rjmp	Check_DSP_BOARD_CS49330
		rjmp	Check_DSP_BOARD_OK

Check_DSP_BOARD_CS49326:
; Check why the Interrupt accours
		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330
		brcs	Check_DSP_BOARD_OK				; Carry is set when no data is present (interrupt off)
												;  in this condition failure is gone and we can go to
												;  normal operation

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
        ldi     r30, LOW(Rd_Audio_Mgr_Response_MSG*2)
        ldi     r31, HIGH(Rd_Audio_Mgr_Response_MSG*2)
		ldi		cl, 3

; Check if readed message from DSP is equal to Autodetect response message
Check_CS49326_VERIFY_LOOP:
        lpm                             		; r0, Z
        adiw    ZL, 1
        mov     al, r0
		ld 		ah, X+							;get data from FIFO
		cp		al, ah
		brne	Check_CS49326_ERROR
		dec		cl
		brne	Check_CS49326_VERIFY_LOOP

; Load Autodetect status bits
		ld 		bl, X+							;get Bits 23:16
		ld 		ah, X+							;get Bits 15:8
		ld 		al, X+							;get Bits 7:0

		cpi		al, DETECT_LinearPCM_Stream
		breq	Check_LD_LinPCM
		cpi		al, DETECT_AC3_Stream
		breq	Check_LD_AC3
		cpi		al, DETECT_PCMcodedAC3_Stream
		breq	Check_LD_AC3
		cpi		al, DETECT_DTS_Stream
		breq	Check_LD_DTS

		rjmp	Check_CS49326_ERROR

;----------------------------------------------------------------------------

Check_LD_LinPCM:
; Check if Dolby ProLogic is enabled 
		ldi		al, DecodeSel_PCMProLogic
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_PROLOGIC
		brne	Check_CS49326_DECODE_SEL_OK

		ldi		al, DecodeSel_PCM
		rjmp	Check_CS49326_DECODE_SEL_OK

Check_LD_AC3:
; Check if Dolby ProLogic is enabled 
		ldi		al, DecodeSel_AC3ProLogic
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_PROLOGIC
		brne	Check_CS49326_DECODE_SEL_OK

		ldi		al, DecodeSel_AC3
		rjmp	Check_CS49326_DECODE_SEL_OK

Check_LD_DTS:
		ldi		al, DecodeSel_DTS
		rjmp	Check_CS49326_DECODE_SEL_OK

;----------------------------------------------------------------------------
Check_CS49326_DECODE_SEL_OK:
		andi	bl, Decodable_Stream_Flag
		brne	Check_CS49326_SOFT_RESET

Check_CS49326_HARD_RESET:
		rcall	HardReset_CS49326
		rjmp	Check_DSP_BOARD_OK

Check_CS49326_SOFT_RESET:
		rcall	SoftReset_CS49326
		rjmp	Check_DSP_BOARD_OK

Check_CS49326_ERROR:

		rjmp	Check_DSP_BOARD_FAIL
;*
;***************************************************************************
;*
Check_DSP_BOARD_CS49330:




		rjmp	Check_DSP_BOARD_OK

Check_CS49330_ERROR:

		rjmp	Check_DSP_BOARD_FAIL

Check_DSP_BOARD_OK:
		ldi		al, 0
		clc
		rjmp	Check_DSP_BOARD_DONE

Check_DSP_BOARD_FAIL:
		ldi		al, 1
		sec

Check_DSP_BOARD_DONE:
		ret
;*
;***************************************************************************


;***************************************************************************
;* Set the DSP Board Operating Mode
;* al = Operatingmode
;*		0 = Boot only DSP1 (CS49326) in Hostmode with AC3 applicationcode
;*		    (For testing purposes and as default in the time where no 
;*			DSP-Flashmemory is present!!!)
;*		1 = Boot DSP1 as Master, DSP2 ignored (For basicly decoding, without 
;*			postprocessing of Audiodata)
;*		2 = Boot DSP2 as Master, DSP1 ignored (For processing PCM-Steams
;*			without decoding any data)
;*		3 = Boot DSP1 as Master and DSP2 as slave (No usable use)
;*		4 = Boot DSP2 as Master and DSP1 as slave (For decoding of data with 
;*			postprocessing for THX)
;***************************************************************************
;*
SetDSPBoardOPMode:
		push	al
		rcall	Init_DSPs
		pop		al
		brcs	SetDSPBoardOPMode_ERROR

		sts		DSPBoardOperatingMode, al
		ldi		bl, EEPROM_DSP_BOARD_MODE_LO
		ldi		bh, EEPROM_DSP_BOARD_MODE_HI
		call	EEWrite	
		ldi		al, 0
		clc
		rjmp	SetDSPBoardOPMode_DONE

SetDSPBoardOPMode_ERROR:
		ldi		al, 1
		sec

SetDSPBoardOPMode_DONE:
		ret
;*
;***************************************************************************


;***************************************************************************
;* Get the DSP Board Operating Mode
;* return al = Operatingmode
;*		0 = Boot only DSP1 (CS49326) in Hostmode with AC3 applicationcode
;*		    (For testing purposes and as default in the time where no 
;*			DSP-Flashmemory is present!!!)
;*		1 = Boot DSP1 as Master, DSP2 ignored (For basicly decoding, without 
;*			postprocessing of Audiodata)
;*		2 = Boot DSP2 as Master, DSP1 ignored (For processing PCM-Steams
;*			without decoding any data)
;*		3 = Boot DSP1 as Master and DSP2 as slave (No usable use)
;*		4 = Boot DSP2 as Master and DSP1 as slave (For decoding of data with 
;*			postprocessing for THX)
;***************************************************************************
;*
GetDSPBoardOPMode:
		lds		al, DSPBoardOperatingMode

GetDSPBoardOPMode_DONE:
		ret
;*
;***************************************************************************


;***************************************************************************
;* Set the Post-Processing Mode
;* al = Post-Processing mode
;*		0 = No Post-Processing active
;*		1 = Crystal Post-Processing active
;*		2 = THX Post-Processing active
;***************************************************************************
;*
SetDSPBoardPPMode:
		push	ah

		lds		ah, DSPBoardMasterFlags
		push	ah

		cpi		al, 0
		breq	SetDSPBoardPPMode_OFF
		cpi		al, 1
		breq	SetDSPBoardPPMode_CPP
		cpi		al, 2
		breq	SetDSPBoardPPMode_THX
		rjmp	SetDSPBoardPPMode_ERROR

SetDSPBoardPPMode_OFF:
		andi	ah, ~(DSPBoardMstrFl_POST_PROC|DSPBoardMstrFl_THX_PROC)
		rjmp	SetDSPBoardPPMode_OK

SetDSPBoardPPMode_CPP:
		ori		ah, DSPBoardMstrFl_POST_PROC
		andi	ah, ~DSPBoardMstrFl_THX_PROC
		rjmp	SetDSPBoardPPMode_OK

SetDSPBoardPPMode_THX:
		ori		ah, (DSPBoardMstrFl_POST_PROC|DSPBoardMstrFl_THX_PROC)

SetDSPBoardPPMode_OK:
		sts		DSPBoardMasterFlags, ah
		rcall	Init_DSPs
		brcs	SetDSPBoardOPMode_ERROR

		lds		al, DSPBoardMasterFlags
		ldi		bl, EEPROM_DSP_BOARD_FLAGS_LO
		ldi		bh, EEPROM_DSP_BOARD_FLAGS_HI
		call	EEWrite	
		ldi		al, 0
		clc
		pop		ah
		rjmp	SetDSPBoardOPMode_DONE

SetDSPBoardPPMode_ERROR:
		pop		ah
		sts		DSPBoardMasterFlags, ah
		ldi		al, 1
		sec

SetDSPBoardPPMode_DONE:
		pop		ah
		ret
;*
;***************************************************************************


;***************************************************************************
;* Get the Post-Processing Mode
;* return al = Post-Processing mode
;*		0 = No Post-Processing active
;*		1 = Crystal Post-Processing active
;*		2 = THX Post-Processing active
;***************************************************************************
;*
GetDSPBoardPPMode:
		push	ah

		ldi		al, 0
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_POST_PROC
		breq	GetDSPBoardPPMode_DONE

		ldi		al, 1
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		breq	GetDSPBoardPPMode_DONE

		ldi		al, 2

GetDSPBoardPPMode_DONE:
		pop		ah
		ret
;*
;***************************************************************************


;***************************************************************************
;* CS42528 Audiocodec Initialization
;***************************************************************************
;*
Init_CS42528:
		rcall	Reset_CODEC

; Wakeup from Powerdownstate
		ldi		bl, CODEC_ADR_PowerControl
		ldi		al, COD_FL__PDN__Default
		sts		CS42528Flags_PowerControl, al
		rcall	Write_CODEC_BYTE

; Set functional mode for CS42528, 192 kbps samplerate, SPDIF on SAI_SDOUT
		ldi		bl, CODEC_ADR_FunctionalMode
		ldi		al, COD_FL__FuncMode__Default
		sts		CS42528Flags_FuncMode, al
		rcall	Write_CODEC_BYTE

; Set interface format to Left Justified, up to 24-bit data, disable "one line mode"
		ldi		bl, CODEC_ADR_InterfaceFormats
		ldi		al, COD_FL__InterfForm__Default
		rcall	Write_CODEC_BYTE

; Set Codec Serialport to slave and serial audio interface port to master 
; and CX_SCLK as clock for external ADCs 
		ldi		al, COD_FL__MiscControl__Def
		ldi		bl, CODEC_ADR_MiscControl
		rcall	Write_CODEC_BYTE

; Set clocks, OMCK Frequency to 12,288 MHz, Auto switch of MCLK
		ldi		bl, CODEC_ADR_ClockControl
		ldi		al, COD_FL__ClockContr__Default
		rcall	Write_CODEC_BYTE

; Set mode control bits, interrupt pin as Active low, De-Emphasis for 48 kHz sample rate, 
		ldi		bl, CODEC_ADR_RCVRModeCtrl
		ldi		al, COD_FL__RCVRMdCtrl__Def
		rcall	Write_CODEC_BYTE

; Route SPDIF input and output from internal SPDIF (PC)
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		ldi		al, COD_FL__RCVRModeCtrl2__Def
		rcall	Write_CODEC_BYTE

; Enable Interruptsources for codec
		ldi		al, COD_FL__InterruptMask_UNLOCKM|COD_FL__InterruptMask_QCHM|COD_FL__InterruptMask_UNLOCKM|COD_FL__InterruptMask_OverFlM|COD_FL__InterruptMask_RERRM
		ldi		bl, CODEC_ADR_InterruptMask
;		rcall	Write_CODEC_BYTE

; Sets interrupt mode to Falling edge active mode
		ldi		al, COD_FL__InterruptModeMSB__Def
		ldi		bl, CODEC_ADR_InterruptModeMSB
		rcall	Write_CODEC_BYTE
		ldi		al, COD_FL__InterruptModeLSB__Def
		ldi		bl, CODEC_ADR_InterruptModeLSB
		rcall	Write_CODEC_BYTE

; Set channels inverts, to correct positions
		ldi		al, COD_FL__ChannelInvert__Def
		ldi		bl, CODEC_ADR_ChannelInvert
		rcall	Write_CODEC_BYTE

; Sets the volume control bits to default
		ldi		al, COD_FL__VolumeControl__Def
		ldi		bl, CODEC_ADR_VolumeControl
		rcall	Write_CODEC_BYTE

; Set the Volume of all channels to default
		lds		al, VOLUME_TOTAL
		call	SetVolume_TOTAL

; Unmute all channels
		ldi		al, COD_FL__ChannelMute__Def
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

		ldi		al, COD_FL__MUTEC__Def
		ldi		bl, CODEC_ADR_MUTEC
		rcall	Write_CODEC_BYTE

; Setup interrupt on falling edge for codec in the ATmega 128
		lds		al, EICRA
		ori  	al, (1<<ISC61)
		sts	 	EICRA, al													; Control Unit: set Interrupt 6 on falling edge 
		in		al, EIMSK
		ori		al, (1<<INT6)
;		out  	EIMSK, al													; Enable interrupt 6

		ret
;*
;***************************************************************************


;***************************************************************************
;* CS8406 SPDIF Audiotransmitter Initialization
;***************************************************************************
;*
Init_CS8406:
		rcall	Reset_SPDIF_TX

; Wakeup from Powerdownstate and OMCK frequency is 256*Fs
		ldi		bl, SPDIF_TX_ADR_ClockSrcCont
		ldi		al, SPDIF_FL__RUN
		rcall	Write_SPDIF_TX_BYTE

; Set interrupt active low, TCBLD as output, unmute transmitter output, set Validity bit
		ldi		bl, SPDIF_TX_ADR_Control1
		ldi		al, SPDIF_FL_Control1__Def
		rcall	Write_SPDIF_TX_BYTE

; Set Transmitter to Stereo Operation
		ldi		bl, SPDIF_TX_ADR_Control2
		ldi		al, SPDIF_FL_Control2__Def
		rcall	Write_SPDIF_TX_BYTE

; Set AES3 Transmitter to normal operation and activate AES3 bypass mode
		ldi		bl, SPDIF_TX_ADR_DataFlowCtrl
		ldi		al, SPDIF_FL_DataFlowCtrl__Def
		rcall	Write_SPDIF_TX_BYTE

; Serial audio input port is in slave mode, ISCLK frequency 64*Fs, 24-bit resolution
; Left-justified, 
		ldi		bl, SPDIF_TX_ADR_SerInputFormat
		ldi		al, SPDIF_FL_SerInputFormat__Def
		rcall	Write_SPDIF_TX_BYTE

; Set Channel Status Data Buffer Control
		ldi		bl, SPDIF_TX_ADR_UDataBufferCtrl
		ldi		al, SPDIF_FL_UDataBufferCtrl__Def
		rcall	Write_SPDIF_TX_BYTE

; Sets Interrupts to Falling edge active and enable AES3 transmitter source data slip interrupt 
		ldi		bl, SPDIF_TX_ADR_Int1ModeLSB
		ldi		al, SPDIF_FL_Int1ModeLSB__Def
		rcall	Write_SPDIF_TX_BYTE
		ldi		bl, SPDIF_TX_ADR_Int1ModeMSB
		ldi		al, SPDIF_FL_Int1ModeMSB__Def
		rcall	Write_SPDIF_TX_BYTE
		ldi		bl, SPDIF_TX_ADR_Int2Mask
		ldi		al, SPDIF_FL_Int2Mask__Def
		rcall	Write_SPDIF_TX_BYTE

		ldi		bl, SPDIF_TX_ADR_Int2ModeLSB
		ldi		al, SPDIF_FL_Int2ModeLSB__Def
		rcall	Write_SPDIF_TX_BYTE
		ldi		bl, SPDIF_TX_ADR_Int2ModeMSB
		ldi		al, SPDIF_FL_Int2ModeMSB__Def
		rcall	Write_SPDIF_TX_BYTE
		ldi		bl, SPDIF_TX_ADR_Int1Mask
		ldi		al, SPDIF_FL_Int1Mask__Def
		rcall	Write_SPDIF_TX_BYTE

; Setup interrupt on falling edge for SPDIF Transmitter in the ATmega 128
		lds		al, EICRA
		ori  	al, (1<<ISC71)
		sts	 	EICRA, al													; Control Unit: set Interrupt 7 on falling edge 
		in		al, EIMSK
		ori		al, (1<<INT7)
;		out  	EIMSK, al													; Enable interrupt 7

		ret
;*
;***************************************************************************


;***************************************************************************
;*
.equ	HW_Hostmode_ConfigMsgSize		= 114
HW_Hostmode_ConfigMsg:	; 114 Bytes
; A - Data Input Type = DAI - PCM and Compressed, CDI - Unused
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0xC0,0x00,0x2C
; B - Data Input Format = PCM - Left Justified 24-bit, Compressed - Left Justified 16-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x10,0x00
					.db 0x80,0x01,0x1A,0x00,0x18,0x00
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF
; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Left Justified 24-bit
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
					.db 0x80,0x01,0x7F,0x01,0x80,0x00
; C - MCLK Frequency = MCLK Frequency 384Fs (32 kbps), (SCLK must be 64Fs in this mode and MCLK must be an input)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
					.db 0x80,0x01,0x7F,0x00,0x08,0x00
; D - SCLK Frequency = 64Fs (192 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x01,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************
;*
.equ	HW_SingleDSP1_ConfigMsgSize		= 114
HW_SingleDSP1_ConfigMsg:
; A - Data Input Type = DAI - PCM and Compressed, CDI - Unused
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0xC0,0x00,0x2C
; B - Data Input Format = PCM - Left Justified 24-bit, Compressed - Left Justified 16-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x10,0x00
					.db 0x80,0x01,0x1A,0x00,0x18,0x00
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF

; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Left Justified 24-bit
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
					.db 0x80,0x01,0x7F,0x01,0x80,0x00
; C - MCLK Frequency = MCLK Frequency 384Fs (32 kbps), (SCLK must be 64Fs in this mode and MCLK must be an input)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
					.db 0x80,0x01,0x7F,0x00,0x08,0x00
; D - SCLK Frequency = 64Fs (192 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x01,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************
;*
.equ	HW_SingleDSP2_ConfigMsgSize		= 114
HW_SingleDSP2_ConfigMsg:
; A - Data Input Type = DAI - PCM and Compressed, CDI - Unused
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0xC0,0x00,0x2C
; B - Data Input Format = PCM - Left Justified 24-bit, Compressed - Left Justified 16-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x10,0x00
					.db 0x80,0x01,0x1A,0x00,0x18,0x00
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF

; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Left Justified 24-bit
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
					.db 0x80,0x01,0x7F,0x01,0x80,0x00
; C - MCLK Frequency = MCLK Frequency 384Fs (32 kbps), (SCLK must be 64Fs in this mode and MCLK must be an input)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
					.db 0x80,0x01,0x7F,0x00,0x08,0x00
; D - SCLK Frequency = 64Fs (192 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x01,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************
;*
.equ	HW_DualModeDSP1Mst_ConfMsgSize			= 108
HW_DualModeDSP1Mst_ConfigMsg:
; A - Data Input Type = DAI - PCM, CDI - Multichannel PCM
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0x80,0x00,0x25
; B - Data Input Format = PCM - Left Justified 24-bit, Multichannel PCM (6 Channel) - Left Justified 24-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x48,0xC0
					.db 0x80,0x01,0x1A,0x00,0x18,0xC0
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF

; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Left Justified 24-bit
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
					.db 0x80,0x01,0x7F,0x01,0x80,0x00
; C - MCLK Frequency = MCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
; D - SCLK Frequency = SCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x03,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************
;*
.equ	HW_DualModeDSP2Mst_ConfMsgSize			= 108
HW_DualModeDSP2Mst_ConfigMsg:
; A - Data Input Type = DAI - PCM, CDI - Multichannel PCM
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0x80,0x00,0x25
; B - Data Input Format = PCM - Left Justified 24-bit, Multichannel PCM (6 Channel) - Left Justified 24-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x48,0xC0
					.db 0x80,0x01,0x1A,0x00,0x18,0xC0
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF

; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Left Justified 24-bit
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
					.db 0x80,0x01,0x7F,0x01,0x80,0x00
; C - MCLK Frequency = MCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
; D - SCLK Frequency = SCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x03,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************
;*
.equ	HW_DualModeDSP1Slv_ConfMsgSize			= 102
HW_DualModeDSP1Slv_ConfigMsg:
; A - Data Type = DAI - PCM, CDI - Multichannel PCM
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0x80,0x00,0x25
; B - Data Format = PCM - Left Justified 24-bit, Compressed - Left Justified 16-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x10,0x00
					.db 0x80,0x01,0x1A,0x00,0x18,0x00
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF

; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Multichannel (6 channel) 24-bit Left Justified 
;                          (SCLK must be at least 256Fs for this mode)
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
; C - MCLK Frequency = MCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
; D - SCLK Frequency = SCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x03,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************
;*
.equ	HW_DualModeDSP2Slv_ConfMsgSize			= 102
HW_DualModeDSP2Slv_ConfigMsg:
; A - Data Type = DAI - PCM, CDI - Multichannel PCM
					.db 0x80,0x02,0x10,0x3F,0xBF,0xC0
					.db 0x80,0x01,0x10,0x80,0x00,0x25
; B - Data Format = PCM - Left Justified 24-bit, Compressed - Left Justified 16-bit
					.db 0x80,0x02,0x17,0x80,0x80,0xFF
					.db 0x80,0x02,0x1A,0x80,0x80,0xFF
					.db 0x80,0x01,0x17,0x00,0x10,0x00
					.db 0x80,0x01,0x1A,0x00,0x18,0x00
; C - SCLK Input Polarity = Data Clocked in on Rising Edge (default)
					.db 0x80,0x02,0x17,0xFF,0xFF,0xDF
					.db 0x80,0x02,0x1A,0xFF,0xFF,0xDF

; A - DAO Mode = MCLK - Slave, SCLK - Master, LRCLK - Master
					.db 0x80,0x02,0x7F,0xBF,0xFF,0xFF
; B - Data Output Format = Multichannel (6 channel) 24-bit Left Justified 
;                          (SCLK must be at least 256Fs for this mode)
					.db 0x80,0x02,0x7F,0xFC,0x7F,0xFF
					.db 0x80,0x02,0x7C,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7D,0xF0,0x1F,0x00
					.db 0x80,0x02,0x7E,0xF0,0x1F,0x00
; C - MCLK Frequency = MCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xE7,0xFF
; D - SCLK Frequency = SCLK Frequency 256Fs (48 kbps)
					.db 0x80,0x02,0x7F,0xFF,0xF8,0xFF
					.db 0x80,0x01,0x7F,0x00,0x03,0x00
; E - SCLK Output Polarity Data Valid on Rising Edge (default)
					.db 0x80,0x02,0x7F,0xF7,0xFF,0xFF
;*
;***************************************************************************


;***************************************************************************
;* Software configuration messages
;***************************************************************************
;*
; Configure DSP to decode PCM-Stream
.equ	PCM_ConfigMsgSize		= 36
PCM_ConfigMsg:	; 
; Set the  XMT958/AUDATA3 Pin to left Justified 24-bit
					.db 0x80,0x02,0x71,0xF8,0x0F,0xFF
					.db 0x80,0x02,0x70,0xF0,0x17,0x00
; Disable decoding of AC3-Stream and enable LFE channel decoding if it is present stream
					.db	0x8A,0x00,0x00,0x00,0x00,0x10
; Enable PCM-Manger (for AC-3 Application Code)
					.db 0x9C,0x00,0x00,0x00,0x00,0x01
; Set samplingrate for PCM to 48 kHz
                    .db 0x88,0x00,0x14,0x00,0x00,0x00
; Enable Kickstart, PLL enable, Autodetect enabled
                    .db 0x88,0x00,0x00,0x00,0x10,0x11
;*
;***************************************************************************
;*
; Configure DSP to ProLogic decode PCM-Stream
.equ	PCMPL_ConfigMsgSize		= 42
PCMPL_ConfigMsg:	; 
; Set the  XMT958/AUDATA3 Pin to left Justified 24-bit
					.db 0x80,0x02,0x71,0xF8,0x0F,0xFF
					.db 0x80,0x02,0x70,0xF0,0x17,0x00
; Disable decoding of AC3-Stream and disable LFE channel decoding
					.db	0x8A,0x00,0x00,0x00,0x00,0x00
; Enable ProLogic, enable autobalance, enable B-Type Noise Reduction
					.db 0x8E,0x00,0x00,0x00,0x01,0x11
; Enable PCM-Manger (for AC-3 Application Code)
					.db 0x9C,0x00,0x00,0x00,0x00,0x01
; Set samplingrate for PCM to 48 kHz
                    .db 0x88,0x00,0x14,0x00,0x00,0x00
; Enable Kickstart, PLL enable, Autodetect enabled
                    .db 0x88,0x00,0x00,0x00,0x10,0x11
;*
;***************************************************************************
;*
; Configure DSP to decode a Dolby Digital 5.1 AC3-Stream
.equ	AC3_ConfigMsgSize		= 42
AC3_ConfigMsg:	;
; Set the  XMT958/AUDATA3 Pin to left Justified 24-bit
					.db 0x80,0x02,0x71,0xF8,0x0F,0xFF
					.db 0x80,0x02,0x70,0xF0,0x17,0x00
; Enable decoding of AC3-Stream and enable LFE channel decoding if it is present stream
					.db	0x8A,0x00,0x00,0x00,0x00,0x11
; Set compression control to line out mode
                    .db 0x8A,0x00,0x02,0x00,0x00,0x02
; Set volume of left surround channel
                    .db 0x88,0x00,0x0a,0x7f,0xff,0xff
; Set volume of right surround channel
                    .db 0x88,0x00,0x0b,0x7f,0xff,0xff
; Enable Kickstart, PLL enable, Autodetect enabled
                    .db 0x88,0x00,0x00,0x00,0x10,0x11
;*
;***************************************************************************
;*
; Configure DSP to decode a Dolby Digital ProLogic 2.0 AC3-Stream
.equ	AC3PL_ConfigMsgSize		= 42
AC3PL_ConfigMsg:	; 
; Set the  XMT958/AUDATA3 Pin to left Justified 24-bit
					.db 0x80,0x02,0x71,0xF8,0x0F,0xFF
					.db 0x80,0x02,0x70,0xF0,0x17,0x00
; Enable ProLogic, enable autobalance, enable B-Type Noise Reduction
					.db 0x8E,0x00,0x00,0x00,0x01,0x11
; Enable decoding of AC3-Stream and enable LFE channel decoding if it is present stream
					.db	0x8A,0x00,0x00,0x00,0x00,0x11
; Set compression control to line out mode
                    .db 0x8A,0x00,0x02,0x00,0x00,0x02
; Set volume of left surround channel
                    .db 0x88,0x00,0x0a,0x7f,0xff,0xff
; Set volume of right surround channel
                    .db 0x88,0x00,0x0b,0x7f,0xff,0xff
; Enable Kickstart, PLL enable, Autodetect enabled
                    .db 0x88,0x00,0x00,0x00,0x10,0x11
;*
;***************************************************************************
;*
; Configure DSP to decode a DTS 5.1 Stream
.equ	DTS_ConfigMsgSize		= 24
DTS_ConfigMsg:	; 
; Set the  XMT958/AUDATA3 Pin to left Justified 24-bit
					.db 0x80,0x02,0x71,0xF8,0x0F,0xFF
					.db 0x80,0x02,0x70,0xF0,0x17,0x00
; Enable decoding of DTS-Stream with 5.1 output
					.db	0x90,0x00,0x00,0x00,0x00,0x71
; Enable Kickstart, PLL enable, Autodetect enabled
                    .db 0x88,0x00,0x00,0x00,0x10,0x11
;*
;***************************************************************************
;*
; Configure DSP to perform Crystal Digital Post Processing
.equ	CrystalDPP_ConfigMsgSize		= 6
CrystalDPP_ConfigMsg:	; 
; Enable Kickstart, PLL enable
                    .db 0x88,0x00,0x00,0x00,0x00,0x11
;*
;***************************************************************************
;*
; Configure DSP to perform THX Post Processing
.equ	THX_ConfigMsgSize		= 0
THX_ConfigMsg:	; 
; Enable Kickstart, PLL enable
 ;                   .db 0x88,0x00,0x00,0x00,0x00,0x11
;*
;***************************************************************************


;***************************************************************************
;* DSP Initialization during system powerup from standby
;* al = Operatingmode
;*		0 = Boot only DSP1 (CS49326) in Hostmode with AC3 applicationcode
;*		    (For testing purposes and as default in the time where no 
;*			DSP-Flashmemory is present!!!)
;*		1 = Boot DSP1 as Master, DSP2 ignored (For basicly decoding, without 
;*			postprocessing of Audiodata)
;*		2 = Boot DSP2 as Master, DSP1 ignored (For processing PCM-Steams
;*			without decoding any data)
;*		3 = Boot DSP1 as Master and DSP2 as slave (No usable use)
;*		4 = Boot DSP2 as Master and DSP1 as slave (For decoding of data with 
;*			postprocessing for THX)
;***************************************************************************
;*
Init_DSPs:
		cpi		al, 0
		brne	Init_DSPs_WRONG_MODE1
		rjmp	Init_DSPs_MODE0

Init_DSPs_WRONG_MODE1:
		cpi		al, 1
		brne	Init_DSPs_WRONG_MODE2
		rjmp	Init_DSPs_MODE1

Init_DSPs_WRONG_MODE2:
		cpi		al, 2
		brne	Init_DSPs_WRONG_MODE3
		rjmp	Init_DSPs_MODE2

Init_DSPs_WRONG_MODE3:
		cpi		al, 3
		brne	Init_DSPs_WRONG_MODE4
		rjmp	Init_DSPs_MODE3

Init_DSPs_WRONG_MODE4:
		cpi		al, 4
		brne	Init_DSPs_WRONG_MODE
		rjmp	Init_DSPs_MODE4

Init_DSPs_WRONG_MODE5:
		cpi		al, 5
		brne	Init_DSPs_WRONG_MODE
		rjmp	Init_DSPs_MODE5

Init_DSPs_WRONG_MODE:
		rjmp	Init_DSPs_ERROR

;-----------------------------------------------------------------------------------------
; Boot only DSP1 (CS49326) in Hostmode with AC3 IBA-Applicationcode
; (For testing purposes and as default in the time where no DSP-Flashmemory is present!!!)
Init_DSPs_MODE0:
		ldi		al, 0xFF
		sts		DSPBoardOperatingMode, al
		sts		DSP_DecodingMode, al

; Select DSP 1 as Master
		ldi		al, 1
		rcall	SelectActiveDSP

; Load Dolby Digital Internal Boot Assistend code (IBA) from ATmega EEprom into DSP 1
		rcall	Hostboot_CS49326
		brcs	Init_DSPs_MODE0_ERROR

; Send Hardware configuration message
        ldi     r30, LOW(HW_Hostmode_ConfigMsg*2)
        ldi     r31, HIGH(HW_Hostmode_ConfigMsg*2)
		ldi		cl, HW_Hostmode_ConfigMsgSize
		rcall	Write_CS49326

; Send Software configuration message
        ldi     r30, LOW(PCM_ConfigMsg*2)
        ldi     r31, HIGH(PCM_ConfigMsg*2)
		ldi		cl, PCM_ConfigMsgSize
		rcall	Write_CS49326

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326

; SRAM canot used by Dolby Digital, disable it
		rcall	Disable_ExternalDSP_MEM

		ldi		al, 0x00
		sts		DSPBoardOperatingMode, al
		ldi		al, DecodeSel_PCM
		sts		DSP_DecodingMode, al
		rjmp	Init_DSPs_OK

Init_DSPs_MODE0_ERROR:

		rjmp	Init_DSPs_ERROR

;-----------------------------------------------------------------------------------------
; Boot DSP1 as Master, DSP2 ignored (For basicly decoding, without postprocessing of 
; Audiodata)
Init_DSPs_MODE1:
		ldi		al, 0xFF
		sts		DSPBoardOperatingMode, al
		sts		DSP_DecodingMode, al

; Select DSP 1 as Master
		ldi		al, 1
		rcall	SelectActiveDSP

; Load Dolby Digital processing code (with PCM-Manager) into DSP 1
		ldi		al, ROMImage1_AC3_PL2_CES
		rcall	Autoboot_CS49326
		brcs	Init_DSPs_MODE1_ERROR

; Enable the External SRAM interface
		rcall	Enable_ExternalDSP_SRAM

; Send Hardware configuration message
        ldi     r30, LOW(HW_SingleDSP1_ConfigMsg*2)
        ldi     r31, HIGH(HW_SingleDSP1_ConfigMsg*2)
		ldi		cl, HW_SingleDSP1_ConfigMsgSize
		rcall	Write_CS49326

; Send Software configuration message
        ldi     r30, LOW(PCM_ConfigMsg*2)
        ldi     r31, HIGH(PCM_ConfigMsg*2)
		ldi		cl, PCM_ConfigMsgSize
		rcall	Write_CS49326

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326

		ldi		al, 0x01
		sts		DSPBoardOperatingMode, al
		ldi		al, DecodeSel_PCM
		sts		DSP_DecodingMode, al
		rjmp	Init_DSPs_OK

Init_DSPs_MODE1_ERROR:

		rjmp	Init_DSPs_ERROR

;-----------------------------------------------------------------------------------------
;
Init_DSPs_MODE2:
		ldi		al, 0xFF
		sts		DSPBoardOperatingMode, al
		sts		DSP_DecodingMode, al

; Select DSP 2 as Master
		ldi		al, 2
		rcall	SelectActiveDSP

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	Init_DSPs_MODE2_PP1_THX				; Jump if Board THX Postprocessing bit is set	

Init_DSPs_MODE2_PP1_DPP:
; Load Crystal Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_DPP8
		rjmp	Init_DSPs_MODE2_PP1_DONE

Init_DSPs_MODE2_PP1_THX:
; Load THX Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_TEXO8_2MB

Init_DSPs_MODE2_PP1_DONE:
		rcall	Autoboot_CS49330
		brcs	Init_DSPs_MODE2_ERROR

; Enable the External SRAM interface
		rcall	Enable_ExternalDSP_SRAM

; Send Hardware configuration message
        ldi     r30, LOW(HW_SingleDSP2_ConfigMsg*2)
        ldi     r31, HIGH(HW_SingleDSP2_ConfigMsg*2)
		ldi		cl, HW_SingleDSP2_ConfigMsgSize
		rcall	Write_CS49330

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	Init_DSPs_MODE2_PP2_THX				; Jump if Board THX Postprocessing bit is set	

Init_DSPs_MODE2_PP2_DPP:
; Send Software configuration message for Crystal Digital Postprocessing
        ldi     r30, LOW(CrystalDPP_ConfigMsg*2)
        ldi     r31, HIGH(CrystalDPP_ConfigMsg*2)
		ldi		cl, CrystalDPP_ConfigMsgSize
		rjmp	Init_DSPs_MODE2_PP2_DONE

Init_DSPs_MODE2_PP2_THX:
; Send Software configuration message for THX Postprocessing
        ldi     r30, LOW(THX_ConfigMsg*2)
        ldi     r31, HIGH(THX_ConfigMsg*2)
		ldi		cl, THX_ConfigMsgSize

Init_DSPs_MODE2_PP2_DONE:
		rcall	Write_CS49330

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330

		ldi		al, 0x02
		sts		DSPBoardOperatingMode, al
		ldi		al, 0xFF
		sts		DSP_DecodingMode, al
		rjmp	Init_DSPs_OK

Init_DSPs_MODE2_ERROR:

		rjmp	Init_DSPs_ERROR

;-----------------------------------------------------------------------------------------
;
Init_DSPs_MODE3:
		ldi		al, 0xFF
		sts		DSPBoardOperatingMode, al
		sts		DSP_DecodingMode, al

; Select DSP 1 as Master
		ldi		al, 1
		rcall	SelectActiveDSP

; Load AC3 processing code into DSP 1
		ldi		al, ROMImage1_AC3_PL2_CES
		rcall	Autoboot_CS49326
		brcs	Init_DSPs_MODE3_ERROR

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	Init_DSPs_MODE3_PP1_THX				; Jump if Board THX Postprocessing bit is set	

Init_DSPs_MODE3_PP1_DPP:
; Load Crystal Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_DPP8
		rjmp	Init_DSPs_MODE3_PP1_DONE

Init_DSPs_MODE3_PP1_THX:
; Load THX Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_TEXO8_2MB

Init_DSPs_MODE3_PP1_DONE:
		rcall	Autoboot_CS49330
		brcs	Init_DSPs_MODE3_ERROR

; Enable the External SRAM interface
		rcall	Enable_ExternalDSP_SRAM

; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP1Mst_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP1Mst_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize
		rcall	Write_CS49326

; Send Hardware configuration message for DSP2
        ldi     r30, LOW(HW_DualModeDSP2Slv_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP2Slv_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP2Slv_ConfMsgSize
		rcall	Write_CS49330

; Send Software configuration message for DSP1
        ldi     r30, LOW(AC3_ConfigMsg*2)
        ldi     r31, HIGH(AC3_ConfigMsg*2)
		ldi		cl, AC3_ConfigMsgSize
		rcall	Write_CS49326

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	Init_DSPs_MODE3_PP2_THX				; Jump if Board THX Postprocessing bit is set	

Init_DSPs_MODE3_PP2_DPP:
; Send Software configuration message for Crystal Digital Postprocessing into DSP2
        ldi     r30, LOW(CrystalDPP_ConfigMsg*2)
        ldi     r31, HIGH(CrystalDPP_ConfigMsg*2)
		ldi		cl, CrystalDPP_ConfigMsgSize
		rjmp	Init_DSPs_MODE3_PP2_DONE

Init_DSPs_MODE3_PP2_THX:
; Send Software configuration message for THX Postprocessing into DSP2
        ldi     r30, LOW(THX_ConfigMsg*2)
        ldi     r31, HIGH(THX_ConfigMsg*2)
		ldi		cl, THX_ConfigMsgSize

Init_DSPs_MODE3_PP2_DONE:
		rcall	Write_CS49330

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330

		ldi		al, 0x03
		sts		DSPBoardOperatingMode, al
		ldi		al, DecodeSel_PCM
		sts		DSP_DecodingMode, al
		rjmp	Init_DSPs_OK

Init_DSPs_MODE3_ERROR:

		rjmp	Init_DSPs_ERROR

;-----------------------------------------------------------------------------------------
;
Init_DSPs_MODE4:
		ldi		al, 0xFF
		sts		DSPBoardOperatingMode, al
		sts		DSP_DecodingMode, al

; Select DSP 2 as Master
		ldi		al, 2
		rcall	SelectActiveDSP

; Load Dolby Digital processing code (with PCM-Manager) into DSP 1
		ldi		al, ROMImage1_AC3_PL2_CES
		rcall	Autoboot_CS49326
		brcs	Init_DSPs_MODE4_ERROR

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	Init_DSPs_MODE4_PP1_THX				; Jump if Board THX Postprocessing bit is set	

Init_DSPs_MODE4_PP1_DPP:
; Load Crystal Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_DPP8
		rjmp	Init_DSPs_MODE4_PP1_DONE

Init_DSPs_MODE4_PP1_THX:
; Load THX Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_TEXO8_2MB

Init_DSPs_MODE4_PP1_DONE:
		rcall	Autoboot_CS49330
		brcs	Init_DSPs_MODE4_ERROR

; Enable the External SRAM interface
		rcall	Enable_ExternalDSP_SRAM

; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP1Slv_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP1Slv_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize
		rcall	Write_CS49326

; Send Hardware configuration message for DSP2
        ldi     r30, LOW(HW_DualModeDSP2Mst_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP2Mst_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP2Mst_ConfMsgSize
		rcall	Write_CS49330

; Send Software configuration message for DSP1
        ldi     r30, LOW(PCM_ConfigMsg*2)
        ldi     r31, HIGH(PCM_ConfigMsg*2)
		ldi		cl, PCM_ConfigMsgSize
		rcall	Write_CS49326

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	Init_DSPs_MODE4_PP2_THX				; Jump if Board THX Postprocessing bit is set	

Init_DSPs_MODE4_PP2_DPP:
; Send Software configuration message for Crystal Digital Postprocessing into DSP2
        ldi     r30, LOW(CrystalDPP_ConfigMsg*2)
        ldi     r31, HIGH(CrystalDPP_ConfigMsg*2)
		ldi		cl, CrystalDPP_ConfigMsgSize
		rjmp	Init_DSPs_MODE4_PP2_DONE

Init_DSPs_MODE4_PP2_THX:
; Send Software configuration message for THX Postprocessing into DSP2
        ldi     r30, LOW(THX_ConfigMsg*2)
        ldi     r31, HIGH(THX_ConfigMsg*2)
		ldi		cl, THX_ConfigMsgSize

Init_DSPs_MODE4_PP2_DONE:
		rcall	Write_CS49330

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330

		ldi		al, 0x04
		sts		DSPBoardOperatingMode, al
		ldi		al, DecodeSel_PCM
		sts		DSP_DecodingMode, al
		rjmp	Init_DSPs_OK

Init_DSPs_MODE4_ERROR:

		rjmp	Init_DSPs_ERROR

;-----------------------------------------------------------------------------------------
;
Init_DSPs_MODE5:
		ldi		al, 0xFF
		sts		DSPBoardOperatingMode, al
		sts		DSP_DecodingMode, al


		rjmp	Init_DSPs_OK

Init_DSPs_MODE5_ERROR:

		rjmp	Init_DSPs_ERROR

Init_DSPs_OK:
		ldi		al, 0
		clc
		rjmp	Init_DSPs_DONE

Init_DSPs_ERROR:
		ldi		al, 1
		sec

Init_DSPs_DONE:

		ret
;*
;***************************************************************************


;***************************************************************************
;* Perform a Hardreset of DSP to load new ROM
;* al = Decodingmode
;***************************************************************************
;*
HardReset_CS49326:
		lds		ah, DSPBoardOperatingMode
		cpi		ah, 0
		breq	HardReset_CS49326_ERR01
		cpi		ah, 2
		breq	HardReset_CS49326_ERR01
		cpi		ah, 5
		brlo	HardReset_CS49326_VALID_MODE

HardReset_CS49326_ERR01:
		ldi		al, 1
		sec
		rjmp	HardReset_CS49326_DONE

HardReset_CS49326_VALID_MODE:
		push	al
; Check which decode mode is in which ROM
		cpi		al, DecodeSel_PCM
		breq	HardReset_AB_ROMImage1_AC3
		cpi		al, DecodeSel_PCMProLogic
		breq	HardReset_AB_ROMImage1_AC3
		cpi		al, DecodeSel_AC3
		breq	HardReset_AB_ROMImage1_AC3
		cpi		al, DecodeSel_AC3ProLogic
		breq	HardReset_AB_ROMImage1_AC3
		cpi		al, DecodeSel_DTS
		breq	HardReset_AB_ROMImage1_DTS
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_
;		cpi		al, 
;		breq	HardReset_AB_CS49326_

		pop		al
		rjmp	HardReset_CS49326_ERR02

HardReset_AB_ROMImage1_AC3:
		ldi		al, ROMImage1_AC3_PL2_CES
		rjmp	HardReset_AB_CS49326_DONE

HardReset_AB_ROMImage1_DTS:
		ldi		al, ROMImage1_DTS_CES
		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

;HardReset_AB_ROMImage1_:
;		ldi		al, ROMImage1_
;		rjmp	HardReset_AB_CS49326_DONE

HardReset_AB_CS49326_DONE:
		rcall	Autoboot_CS49326
		pop		al
		brcs	HardReset_CS49326_ERR02

; Load corresponding to Operting mode the correct hardwaremessage
		lds		ah, DSPBoardOperatingMode
		cpi		ah, 4
		breq	HardReset_CS49326_MODE4
		cpi		ah, 3
		breq	HardReset_CS49326_MODE3

HardReset_CS49326_MODE1:
; Send Hardware configuration message
        ldi     r30, LOW(HW_SingleDSP1_ConfigMsg*2)
        ldi     r31, HIGH(HW_SingleDSP1_ConfigMsg*2)
		ldi		cl, HW_SingleDSP1_ConfigMsgSize
		rjmp	HardReset_CS49326_HW_DONE

HardReset_CS49326_MODE3:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP1Mst_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP1Mst_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize
		rjmp	HardReset_CS49326_HW_DONE

HardReset_CS49326_MODE4:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP1Slv_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP1Slv_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize

HardReset_CS49326_HW_DONE:
		rcall	Write_CS49326

		cpi		al, DecodeSel_PCM
		breq	HardReset_SW_CS49326_PCM
		cpi		al, DecodeSel_PCMProLogic
		breq	HardReset_SW_CS49326_PCM_PL
		cpi		al, DecodeSel_AC3
		breq	HardReset_SW_CS49326_AC3
		cpi		al, DecodeSel_AC3ProLogic
		breq	HardReset_SW_CS49326_AC3_PL
		cpi		al, DecodeSel_DTS
		breq	HardReset_SW_CS49326_DTS
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
;		cpi		al, DecodeSel_
;		breq	HardReset_SW_CS49326_
		rjmp	HardReset_CS49326_ERR02

HardReset_SW_CS49326_PCM:
; Send Software configuration message for DSP1
        ldi     r30, LOW(PCM_ConfigMsg*2)
        ldi     r31, HIGH(PCM_ConfigMsg*2)
		ldi		cl, PCM_ConfigMsgSize
		rjmp	HardReset_SW_CS49326_DONE

HardReset_SW_CS49326_PCM_PL:
; Send Software configuration message for DSP1
        ldi     r30, LOW(PCMPL_ConfigMsg*2)
        ldi     r31, HIGH(PCMPL_ConfigMsg*2)
		ldi		cl, PCMPL_ConfigMsgSize
		rjmp	HardReset_SW_CS49326_DONE

HardReset_SW_CS49326_AC3:
; Send Software configuration message for DSP1
        ldi     r30, LOW(AC3_ConfigMsg*2)
        ldi     r31, HIGH(AC3_ConfigMsg*2)
		ldi		cl, AC3_ConfigMsgSize
		rjmp	HardReset_SW_CS49326_DONE

HardReset_SW_CS49326_AC3_PL:
; Send Software configuration message for DSP1
        ldi     r30, LOW(AC3PL_ConfigMsg*2)
        ldi     r31, HIGH(AC3PL_ConfigMsg*2)
		ldi		cl, AC3PL_ConfigMsgSize
		rjmp	HardReset_SW_CS49326_DONE

HardReset_SW_CS49326_DTS:
; Send Software configuration message for DSP1
        ldi     r30, LOW(DTS_ConfigMsg*2)
        ldi     r31, HIGH(DTS_ConfigMsg*2)
		ldi		cl, DTS_ConfigMsgSize
		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

;HardReset_SW_CS49326_:
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;		rjmp	HardReset_SW_CS49326_DONE

HardReset_SW_CS49326_DONE:
		rcall	Write_CS49326
		sts		DSP_DecodingMode, al
		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326

HardReset_CS49326_OK:
		ldi		al, 0
		clc
		rjmp	HardReset_CS49326_DONE

HardReset_CS49326_ERR02:
		ldi		al, 1
		sec
		rjmp	HardReset_CS49326_DONE

HardReset_CS49326_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Perform a Softreset of DSP to load new mode in current ROM
;* al = Decodingmode
;***************************************************************************
;*
SoftReset_MSG:		.db 0x00,0x00,0x01,  0x00

SoftReset_CS49326:
		push	al
		call	Reset_CS49326

; Send softreset message (0x000004)
        ldi     r30, LOW(SoftReset_MSG*2)
        ldi     r31, HIGH(SoftReset_MSG*2)
		ldi		cl, 3
		rcall	Write_CS49326

; Wait 5 ms
		ldi		cl, 5
		call	WaitDelay
		pop		al

		lds		ah, DSPBoardOperatingMode
		cpi		ah, 0
		breq	SoftReset_CS49326_MODE0
		cpi		ah, 1
		breq	SoftReset_CS49326_MODE1
		cpi		ah, 2
		breq	SoftReset_CS49326_MODE2
		cpi		ah, 3
		breq	SoftReset_CS49326_MODE3
		cpi		ah, 4
		breq	SoftReset_CS49326_MODE4
		cpi		ah, 5
		breq	SoftReset_CS49326_MODE5

		ldi		al, 1
		sec
		rjmp	SoftReset_CS49326_DONE

SoftReset_CS49326_MODE0:
; Send Hardware configuration message
        ldi     r30, LOW(HW_Hostmode_ConfigMsg*2)
        ldi     r31, HIGH(HW_Hostmode_ConfigMsg*2)
		ldi		cl, HW_Hostmode_ConfigMsgSize
		rjmp	SoftReset_CS49326_HW_DONE

SoftReset_CS49326_MODE1:
; Send Hardware configuration message
        ldi     r30, LOW(HW_SingleDSP1_ConfigMsg*2)
        ldi     r31, HIGH(HW_SingleDSP1_ConfigMsg*2)
		ldi		cl, HW_SingleDSP1_ConfigMsgSize
		rjmp	SoftReset_CS49326_HW_DONE

SoftReset_CS49326_MODE2:
; Mode 2 dont use DSP1
		ldi		al, 1
		sec
		rjmp	SoftReset_CS49326_DONE

SoftReset_CS49326_MODE3:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP1Mst_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP1Mst_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize
		rjmp	SoftReset_CS49326_HW_DONE

SoftReset_CS49326_MODE4:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP1Slv_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP1Slv_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize
		rjmp	SoftReset_CS49326_HW_DONE

SoftReset_CS49326_MODE5:
; Mode 5 not used at this time
		ldi		al, 1
		sec
		rjmp	SoftReset_CS49326_DONE

SoftReset_CS49326_HW_DONE:
		rcall	Write_CS49326

		cpi		al, DecodeSel_PCM
		breq	SoftReset_CS49326_PCM
		cpi		al, DecodeSel_PCMProLogic
		breq	SoftReset_CS49326_PCM_PL
		cpi		al, DecodeSel_AC3
		breq	SoftReset_CS49326_AC3
		cpi		al, DecodeSel_AC3ProLogic
		breq	SoftReset_CS49326_AC3_PL
		cpi		al, DecodeSel_DTS
		breq	SoftReset_CS49326_DTS
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_
;		cpi		al, DecodeSel_
;		breq	SoftReset_CS49326_

		ldi		al, 1
		sec
		rjmp	SoftReset_CS49326_DONE

SoftReset_CS49326_PCM:
; Send Software configuration message for DSP1
        ldi     r30, LOW(PCM_ConfigMsg*2)
        ldi     r31, HIGH(PCM_ConfigMsg*2)
		ldi		cl, PCM_ConfigMsgSize
		rjmp	SoftReset_CS49326_SW_DONE

SoftReset_CS49326_PCM_PL:
; Send Software configuration message for DSP1
        ldi     r30, LOW(PCMPL_ConfigMsg*2)
        ldi     r31, HIGH(PCMPL_ConfigMsg*2)
		ldi		cl, PCMPL_ConfigMsgSize
		rjmp	SoftReset_CS49326_SW_DONE

SoftReset_CS49326_AC3:
; Send Software configuration message for DSP1
        ldi     r30, LOW(AC3_ConfigMsg*2)
        ldi     r31, HIGH(AC3_ConfigMsg*2)
		ldi		cl, AC3_ConfigMsgSize
		rjmp	SoftReset_CS49326_SW_DONE

SoftReset_CS49326_AC3_PL:
; Send Software configuration message for DSP1
        ldi     r30, LOW(AC3PL_ConfigMsg*2)
        ldi     r31, HIGH(AC3PL_ConfigMsg*2)
		ldi		cl, AC3PL_ConfigMsgSize
		rjmp	SoftReset_CS49326_SW_DONE

SoftReset_CS49326_DTS:
; Send Software configuration message for DSP1
        ldi     r30, LOW(DTS_ConfigMsg*2)
        ldi     r31, HIGH(DTS_ConfigMsg*2)
		ldi		cl, DTS_ConfigMsgSize
		rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

;SoftReset_CS49326_
; Send Software configuration message for DSP1
;       ldi     r30, LOW(_ConfigMsg*2)
;       ldi     r31, HIGH(_ConfigMsg*2)
;		ldi		cl, _ConfigMsgSize
;	  	rjmp	SoftReset_CS49326_SW_DONE

SoftReset_CS49326_SW_DONE:
		rcall	Write_CS49326
		sts		DSP_DecodingMode, al
		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326

		ldi		al, 0
		clc

SoftReset_CS49326_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Perform a Hardreset of DSP 2 to reload ROM
;***************************************************************************
;*
HardReset_CS49330:
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_POST_PROC
		brne	HardReset_CS49330_ON				; Jump if Board  Postprocessing bit is set
		rjmp	HardReset_CS49330_OK

HardReset_CS49330_ON:
		lds		ah, DSPBoardOperatingMode
		cpi		ah, 0
		breq	HardReset_CS49330_ERR01
		cpi		ah, 1
		breq	HardReset_CS49330_ERR01
		cpi		ah, 5
		brlo	HardReset_CS49330_VALID_MODE

HardReset_CS49330_ERR01:
		ldi		al, 1
		sec
		rjmp	HardReset_CS49330_DONE

HardReset_CS49330_VALID_MODE:
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	HardReset_CS49330_PP1_THX				; Jump if Board THX Postprocessing bit is set	

HardReset_CS49330_PP1_DPP:
; Load Crystal Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_DPP8
		rjmp	HardReset_CS49330_PP1_DONE

HardReset_CS49330_PP1_THX:
; Load THX Digital Post Processing code into DSP 2
		ldi		al, ROMImage2_TEXO8_2MB

HardReset_CS49330_PP1_DONE:
		rcall	Autoboot_CS49330
		brcs	HardReset_CS49330_ERR02

; Load corresponding to Operting mode the correct hardwaremessage
		lds		ah, DSPBoardOperatingMode
		cpi		ah, 4
		breq	HardReset_CS49330_MODE4
		cpi		ah, 3
		breq	HardReset_CS49330_MODE3

HardReset_CS49330_MODE2:
; Send Hardware configuration message
        ldi     r30, LOW(HW_SingleDSP2_ConfigMsg*2)
        ldi     r31, HIGH(HW_SingleDSP2_ConfigMsg*2)
		ldi		cl, HW_SingleDSP1_ConfigMsgSize
		rjmp	HardReset_CS49330_HW_DONE

HardReset_CS49330_MODE3:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP2Slv_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP2Slv_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP2Slv_ConfMsgSize
		rjmp	HardReset_CS49330_HW_DONE

HardReset_CS49330_MODE4:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP2Mst_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP2Mst_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize

HardReset_CS49330_HW_DONE:
		rcall	Write_CS49330

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	HardReset_CS49330_PP2_THX			; Jump if Board THX Postprocessing bit is set	

HardReset_CS49330_PP2_DPP:
; Send Software configuration message for Crystal Digital Postprocessing into DSP2
        ldi     r30, LOW(CrystalDPP_ConfigMsg*2)
        ldi     r31, HIGH(CrystalDPP_ConfigMsg*2)
		ldi		cl, CrystalDPP_ConfigMsgSize
		rjmp	HardReset_SW_CS49330_DONE

HardReset_CS49330_PP2_THX:
; Send Software configuration message for THX Postprocessing into DSP2
        ldi     r30, LOW(THX_ConfigMsg*2)
        ldi     r31, HIGH(THX_ConfigMsg*2)
		ldi		cl, THX_ConfigMsgSize

HardReset_SW_CS49330_DONE:
		rcall	Write_CS49330
		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330

HardReset_CS49330_OK:
		ldi		al, 0
		clc
		rjmp	HardReset_CS49330_DONE

HardReset_CS49330_ERR02:
		ldi		al, 1
		sec
		rjmp	HardReset_CS49330_DONE

HardReset_CS49330_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* 
;***************************************************************************
;*
SoftReset_CS49330:
		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_POST_PROC
		brne	SoftReset_CS49330_ON				; Jump if Board  Postprocessing bit is set
		rjmp	SoftReset_CS49330_OK

SoftReset_CS49330_ON:
		lds		ah, DSPBoardOperatingMode
		cpi		ah, 0
		breq	SoftReset_CS49330_ERR01
		cpi		ah, 1
		breq	SoftReset_CS49330_ERR01
		cpi		ah, 5
		brlo	SoftReset_CS49330_VALID_MODE

SoftReset_CS49330_ERR01:
		ldi		al, 1
		sec
		rjmp	SoftReset_CS49330_DONE

SoftReset_CS49330_VALID_MODE:
		rcall	Reset_CS49330

; Send softreset message (0x000004)
        ldi     r30, LOW(SoftReset_MSG*2)
        ldi     r31, HIGH(SoftReset_MSG*2)
		ldi		cl, 3
		rcall	Write_CS49326

; Wait 5 ms
		ldi		cl, 5
		call	WaitDelay
		pop		al

; Load corresponding to Operting mode the correct hardwaremessage
		lds		ah, DSPBoardOperatingMode
		cpi		ah, 4
		breq	SoftReset_CS49330_MODE4
		cpi		ah, 3
		breq	SoftReset_CS49330_MODE3

SoftReset_CS49330_MODE2:
; Send Hardware configuration message
        ldi     r30, LOW(HW_SingleDSP2_ConfigMsg*2)
        ldi     r31, HIGH(HW_SingleDSP2_ConfigMsg*2)
		ldi		cl, HW_SingleDSP1_ConfigMsgSize
		rjmp	SoftReset_CS49330_HW_DONE

SoftReset_CS49330_MODE3:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP2Slv_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP2Slv_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP2Slv_ConfMsgSize
		rjmp	SoftReset_CS49330_HW_DONE

SoftReset_CS49330_MODE4:
; Send Hardware configuration message for DSP1
        ldi     r30, LOW(HW_DualModeDSP2Mst_ConfigMsg*2)
        ldi     r31, HIGH(HW_DualModeDSP2Mst_ConfigMsg*2)
		ldi		cl, HW_DualModeDSP1Slv_ConfMsgSize

SoftReset_CS49330_HW_DONE:
		rcall	Write_CS49330

		lds		ah, DSPBoardMasterFlags
		andi	ah, DSPBoardMstrFl_THX_PROC
		brne	SoftReset_CS49330_PP2_THX			; Jump if Board THX Postprocessing bit is set	

SoftReset_CS49330_PP2_DPP:
; Send Software configuration message for Crystal Digital Postprocessing into DSP2
        ldi     r30, LOW(CrystalDPP_ConfigMsg*2)
        ldi     r31, HIGH(CrystalDPP_ConfigMsg*2)
		ldi		cl, CrystalDPP_ConfigMsgSize
		rjmp	SoftReset_SW_CS49330_DONE

SoftReset_CS49330_PP2_THX:
; Send Software configuration message for THX Postprocessing into DSP2
        ldi     r30, LOW(THX_ConfigMsg*2)
        ldi     r31, HIGH(THX_ConfigMsg*2)
		ldi		cl, THX_ConfigMsgSize

SoftReset_SW_CS49330_DONE:
		rcall	Write_CS49330

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330

SoftReset_CS49330_OK:
		ldi		al, 0
		clc
		rjmp	SoftReset_CS49330_DONE

SoftReset_CS49330_ERR02:
		ldi		al, 1
		sec
		rjmp	SoftReset_CS49330_DONE

SoftReset_CS49330_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* CS49326 DSP Hostboot procedure (For testing purposes and as default in
;* the time where no DSP-Flashmemory is present!!!)
;* Loads default AC3 code from EEprom into DSP
;***************************************************************************
;*
dlboot_MSG:			.db 0x00,0x00,0x04,  0x00
bootSucRecv_MSG: 	.db 0x00,0x00,0x05,  0x00

Hostboot_CS49326:
		rcall	Disable_ExternalDSP_MEM
		rcall	Reset_CS49326
; wait 500 s
		ldi		cl, 1
		call	WaitDelay

; DOWNLOAD_BOOT (0x000004)
        ldi     r30, LOW(dlboot_MSG*2)
        ldi     r31, HIGH(dlboot_MSG*2)
		ldi		cl, 3
		rcall	Write_CS49326

; wait for boot msg
		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326
		brcs	Hostboot_CS49326_FAIL1
		ld 		al, X+							;get data from FIFO
		cpi		al, BOOT_START
		brne	Hostboot_CS49326_FAIL1

		in		al, PORTA
		andi	al, ~(1<<DSP_1_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

; sets the chip into write mode
		ldi		al, DSP1_HW_ADR | DSP1_WRITE
		call	SPI_MasterTransmit

		ldi		ch, 0x05						; 1290 Bytes
		ldi		cl, 0x0A
		ldi		bl, EPPROM_AC3_IBACODE_LO							; Load address of IBA-Code in EEprom memory
		ldi		bh, EPPROM_AC3_IBACODE_HI					;  

; transfer IBA code to DSP
Hostboot_CS49326_LOOP:
		call	EERead							;get data from EEprom
 		call	SPI_MasterTransmit
		ldi		al, 1
		add		bl, al
		ldi		al, 0
		adc		bh, al
		dec		cl
        brne    Hostboot_CS49326_LOOP
		dec		ch
        brne    Hostboot_CS49326_LOOP

		in		al, PORTA
		ori		al, (1<<DSP_1_CS)
		out 	PORTA, al

; see if code dl was a success
		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326
		brcs	Hostboot_CS49326_FAIL1
		ld 		al, X+							;get data from FIFO
		cpi		al, BOOT_SUCCESS
		brne	Hostboot_CS49326_FAIL2

; Write Boot Success Recv 0x000005
        ldi     r30, LOW(bootSucRecv_MSG*2)
        ldi     r31, HIGH(bootSucRecv_MSG*2)
		ldi		cl, 3
		rcall	Write_CS49326

		ldi		al, 0
		clc
		rjmp	Hostboot_CS49326_DONE

; if error occurs at boot start
Hostboot_CS49326_FAIL1:
		ldi		al, 1
		sec
		rjmp	Hostboot_CS49326_DONE

; if error occurs at app code dl
Hostboot_CS49326_FAIL2:
		ldi		al, 2
		sec

Hostboot_CS49326_DONE:
		ret
;*
;***************************************************************************


;***************************************************************************
;* CS49326 DSP Autoboot procedure
;* Loads slected code from External DSP Flash into DSP
;* al = Flashprogram to boot (0-15 = Program)
;***************************************************************************
;*
Rd_Audio_Mgr_Request_MSG:			.db 0x09,0x00,0x03,                0x00
Rd_Audio_Mgr_Response_MSG:			.db 0x89,0x00,0x03,0x00,0x00,0x00

Autoboot_CS49326:
		rcall	Select_CS49326_FlashProgram
		rcall	Enable_ExternalDSP_FLASH
		cli

; Make sure reset pin is high (no reset condition)
		in		al, PORTA
		ori		al, (1<<DSP_1_RESET)
		out 	PORTA, al

; Hold down reset
		in		al, PORTA
		andi	al, ~(1<<DSP_1_RESET)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

; For Autoboot the Interruptpin must be hold low during reset, 
; set in now as output and hold it low
		in		al, DDRE
		ori		al, (1<<DSP1_IRQ)
		out		DDRE, al

		ldi		cl, 1
		call	WaitDelay

		in		al, PORTE
		andi	al, ~(1<<DSP1_AUTOBOOT)
		out 	PORTE, al 

		ldi		cl, 3
		call	WaitDelay

; Leave resetstate
		in		al, PORTA
		ori		al, (1<<DSP_1_RESET)
		out 	PORTA, al

		ldi		cl, 2
		call	WaitDelay

; set autoboot pin back as interrupt input
		in		al, DDRE
		andi	al, ~(1<<DSP1_IRQ)
		out		DDRE, al
		in		al, PORTE
		andi	al, ~(1<<DSP1_AUTOBOOT)
		out 	PORTE, al 

		sei
		ldi		ch, 2							; Two rereads if it was not sucessfull

Autoboot_CS49326_READ_AGAIN:
		dec		ch
		breq	Autoboot_CS49326_FAIL2

; Wait 200 ms
		ldi		cl, 200
		call	WaitDelay

; Read a value from DSP and compare it with known value
; if it is equal code was loaded sucessfully
        ldi     r30, LOW(Rd_Audio_Mgr_Request_MSG*2)
        ldi     r31, HIGH(Rd_Audio_Mgr_Request_MSG*2)
		ldi		cl, 3
		rcall	Write_CS49326

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49326
		brcs	Autoboot_CS49326_READ_AGAIN

        ldi     r30, LOW(Rd_Audio_Mgr_Response_MSG*2)
        ldi     r31, HIGH(Rd_Audio_Mgr_Response_MSG*2)
		ldi		cl, 3							; 3 Bytes to compare

Autoboot_CS49326_VERIFY_LOOP:
        lpm                             		; r0, Z
        adiw    ZL, 1
        mov     al, r0
		ld 		ah, X+							;get data from FIFO
		cp		al, ah
		brne	Autoboot_CS49326_READ_AGAIN
		dec		cl
		brne	Autoboot_CS49326_VERIFY_LOOP

		ldi		al, 0
		clc
		rjmp	Autoboot_CS49326_DONE

; if error occurs at boot start
Autoboot_CS49326_FAIL1:
		ldi		al, 1
		sec
		rjmp	Autoboot_CS49326_DONE

; if error occurs at app code dl
Autoboot_CS49326_FAIL2:
		ldi		al, 2
		sec

Autoboot_CS49326_DONE:
		rcall	Disable_ExternalDSP_MEM
		ret
;*
;***************************************************************************


;***************************************************************************
;* CS49330 DSP Autoboot procedure
;* Loads slected code from External DSP Flash into DSP
;* al = Flashprogram to boot (0-15 = Program)
;***************************************************************************
;*
;Rd_Audio_Mgr_Request_MSG:			.db 0x09,0x00,0x03,                0x00
;Rd_Audio_Mgr_Response_MSG:			.db 0x89,0x00,0x03,0x00,0x00,0x00

Autoboot_CS49330:
		rcall	Select_CS49330_FlashProgram
		rcall	Enable_ExternalDSP_FLASH
		cli

; Make sure reset pin is high (no reset condition)
		in		al, PORTA
		ori		al, (1<<DSP_2_RESET)
		out 	PORTA, al

; Hold down reset
		in		al, PORTA
		andi	al, ~(1<<DSP_2_RESET)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

; For Autoboot the Interruptpin must be hold low during reset, 
; set in now as output and hold it low
		in		al, DDRE
		ori		al, (1<<DSP2_IRQ)
		out		DDRE, al

		ldi		cl, 1
		call	WaitDelay

		in		al, PORTE
		andi	al, ~(1<<DSP2_AUTOBOOT)
		out 	PORTE, al 

		ldi		cl, 3
		call	WaitDelay

; Leave resetstate
		in		al, PORTA
		ori		al, (1<<DSP_2_RESET)
		out 	PORTA, al

		ldi		cl, 2
		call	WaitDelay

; set autoboot pin back as interrupt input
		in		al, DDRE
		andi	al, ~(1<<DSP2_IRQ)
		out		DDRE, al
		in		al, PORTE
		andi	al, ~(1<<DSP2_AUTOBOOT)
		out 	PORTE, al 

		sei
		ldi		ch, 2							; Two rereads if it was not sucessfull

Autoboot_CS49330_READ_AGAIN:
		dec		ch
		breq	Autoboot_CS49330_FAIL2

; Wait 200 ms
		ldi		cl, 200
		call	WaitDelay

; Read a value from DSP and compare it with known value
; if it is equal code was loaded sucessfully
        ldi     r30, LOW(Rd_Audio_Mgr_Request_MSG*2)
        ldi     r31, HIGH(Rd_Audio_Mgr_Request_MSG*2)
		ldi		cl, 3
		rcall	Write_CS49330

		ldi 	XL, LOW(DSP_ReceiveBuffer)			;
		ldi		XH, HIGH(DSP_ReceiveBuffer)
		rcall	Read_CS49330
		brcs	Autoboot_CS49330_READ_AGAIN

        ldi     r30, LOW(Rd_Audio_Mgr_Response_MSG*2)
        ldi     r31, HIGH(Rd_Audio_Mgr_Response_MSG*2)
		ldi		cl, 3							; 3 Bytes to compare

Autoboot_CS49330_VERIFY_LOOP:
        lpm                             		; r0, Z
        adiw    ZL, 1
        mov     al, r0
		ld 		ah, X+							;get data from FIFO
		cp		al, ah
		brne	Autoboot_CS49330_READ_AGAIN
		dec		cl
		brne	Autoboot_CS49330_VERIFY_LOOP

		ldi		al, 0
		clc
		rjmp	Autoboot_CS49330_DONE

; if error occurs at boot start
Autoboot_CS49330_FAIL1:
		ldi		al, 1
		sec
		rjmp	Autoboot_CS49330_DONE

; if error occurs at app code dl
Autoboot_CS49330_FAIL2:
		ldi		al, 2
		sec

Autoboot_CS49330_DONE:
		rcall	Disable_ExternalDSP_MEM
		ret
;*
;***************************************************************************


;***************************************************************************
;* Enable external SRAM interface for both DSPs (Flash was disabled)
;***************************************************************************
;*
Enable_ExternalDSP_SRAM:
		lds		al, PORTG
		ori		al, (1<<DSP_SRAM_SEL)
		andi	al, ~(1<<DSP_FLASH_SEL)
		sts		PORTG, al
		ret
;*
;***************************************************************************


;***************************************************************************
;* Enable external Flash interface for both DSPs (SRAM was disabled)
;***************************************************************************
;*
Enable_ExternalDSP_FLASH:
		lds		al, PORTG
		ori		al, (1<<DSP_FLASH_SEL)
		andi	al, ~(1<<DSP_SRAM_SEL)
		sts		PORTG, al
		ret
;*
;***************************************************************************


;***************************************************************************
;* Disable external SRAM and Flash interface for both DSPs
;***************************************************************************
;*
Disable_ExternalDSP_MEM:
		lds		al, PORTG
		andi	al, ~(1<<DSP_FLASH_SEL)|(1<<DSP_SRAM_SEL)
		sts		PORTG, al
		ret
;*
;***************************************************************************


;***************************************************************************
;* Write multiple Bytes to CS49326
;* in:	Z  = Address to data in programmemory
;*		cl = Bytes zo write
;* out: none
;***************************************************************************
;*
Write_CS49326:
		push	r0
		push	al
		push	cl
		push	ZL
		push	ZH

		in		al, PORTA
		andi	al, ~(1<<DSP_1_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, DSP1_HW_ADR | DSP1_WRITE
		call	SPI_MasterTransmit

Write_CS49326_LOOP:
        lpm                             ; r0, Z
        adiw    ZL, 1
        mov     al, r0
 		call	SPI_MasterTransmit
		dec		cl
        brne    Write_CS49326_LOOP

		in		al, PORTA
		ori		al, (1<<DSP_1_CS)
		out 	PORTA, al

		ldi		cl, 1
		call	WaitDelay

		pop		ZH
		pop		ZL
		pop		cl
		pop		al
		pop		r0
		ret	
;*
;***************************************************************************


;***************************************************************************
;* Read multiple Bytes from CS49326
;* in:	X  = Address to databuffer
;* out: cl = Bytes readed
;***************************************************************************
;*
Read_CS49326:
		push	r0
		push	al
		push	XL
		push	XH

; wait for response
		ldi		cl, 20

Read_CS49326_WAIT:
		sbis	PINE, DSP1_IRQ											;
		rjmp	Read_CS49326_READ

		push	cl
		ldi		cl, 1
		call	WaitDelay
		pop		cl
		dec		cl
		brne	Read_CS49326_WAIT
		rjmp	Read_CS49326_FAIL

Read_CS49326_READ:
		in		al, PORTA
		andi	al, ~(1<<DSP_1_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, DSP1_HW_ADR | DSP1_READ
		call	SPI_MasterTransmit
		ldi		cl, 0

Read_CS49326_LOOP:
 		call	SPI_MasterReceive
		inc		cl
		st 		X+, al							;X+ = data
		sbis	PINE, DSP1_IRQ
        rjmp    Read_CS49326_LOOP

		in		al, PORTA
		ori		al, (1<<DSP_1_CS)
		out 	PORTA, al

		push	cl
		ldi		cl, 1
		call	WaitDelay
		pop		cl

Read_CS49326_OK:
		clc
		rjmp	Read_CS49326_DONE

Read_CS49326_FAIL:
		sec

Read_CS49326_DONE:
		pop		XH
		pop		XL
		pop		al
		pop		r0
		ret	
;*
;***************************************************************************


;***************************************************************************
;* Write multiple Bytes to CS49330
;* in:	Z  = Address to data in programmemory
;*		cl = Bytes zo write
;* out: none
;***************************************************************************
;*
Write_CS49330:
		push	r0
		push	al
		push	cl
		push	ZL
		push	ZH

		in		al, PORTA
		andi	al, ~(1<<DSP_2_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, DSP2_HW_ADR | DSP2_WRITE
		call	SPI_MasterTransmit

Write_CS49330_LOOP:
        lpm                             ; r0, Z
        adiw    ZL, 1
        mov     al, r0
 		call	SPI_MasterTransmit
		dec		cl
        brne    Write_CS49330_LOOP

		in		al, PORTA
		ori		al, (1<<DSP_2_CS)
		out 	PORTA, al

		ldi		cl, 1
		call	WaitDelay

		pop		ZH
		pop		ZL
		pop		cl
		pop		al
		pop		r0
		ret	
;*
;***************************************************************************


;***************************************************************************
;* Read multiple Bytes from CS49330
;* in:	X  = Address to databuffer
;* out: cl = Bytes readed
;***************************************************************************
;*
Read_CS49330:
		push	r0
		push	al
		push	XL
		push	XH

; wait for response
		ldi		cl, 20

Read_CS49330_WAIT:
		sbis	PINE, DSP2_IRQ											;
		rjmp	Read_CS49330_READ

		push	cl
		ldi		cl, 1
		call	WaitDelay
		pop		cl
		dec		cl
		brne	Read_CS49330_WAIT
		rjmp	Read_CS49330_FAIL

Read_CS49330_READ:
		in		al, PORTA
		andi	al, ~(1<<DSP_2_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, DSP2_HW_ADR | DSP2_READ
		call	SPI_MasterTransmit
		ldi		cl, 0

Read_CS49330_LOOP:
 		call	SPI_MasterReceive
		inc		cl
		st 		X+, al							;X+ = data
		sbis	PINE, DSP1_IRQ	
        rjmp    Read_CS49330_LOOP

		in		al, PORTA
		ori		al, (1<<DSP_2_CS)
		out 	PORTA, al

		push	cl
		ldi		cl, 1
		call	WaitDelay
		pop		cl

Read_CS49330_OK:
		clc
		rjmp	Read_CS49330_DONE

Read_CS49330_FAIL:
		sec

Read_CS49330_DONE:
		pop		XH
		pop		XL
		pop		al
		pop		r0
		ret	
;*
;***************************************************************************


;***************************************************************************
;* 
;***************************************************************************
;*
Reset_CS49326:
		in		al, PORTA
		andi	al, ~(1<<DSP_1_RESET)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		in		al, PORTA
		ori		al, (1<<DSP_1_RESET)
		out 	PORTA, al

		ldi		cl, 3
		call	WaitDelay
		ret 
;*
;***************************************************************************


;***************************************************************************
;* 
;***************************************************************************
;*
Reset_CS49330:
		in		al, PORTA
		andi	al, ~(1<<DSP_2_RESET)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		in		al, PORTA
		ori		al, (1<<DSP_2_RESET)
		out 	PORTA, al

		ldi		cl, 3
		call	WaitDelay
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Select the Applicationcodepage in the Flashmemory for the CS49326
;* al = Flashprogram (0-15 = Program)
;***************************************************************************
;*
Select_CS49326_FlashProgram:
		push	al
		push	ah

		andi	al, 0x0F				; clear upper 4 bits

		lds		ah, PORTF
		andi	ah, 0xF0				; clear lower 4 bits
		or		ah, al
		sts		PORTF, ah

Select_CS49326_Flash_DONE:
		pop		ah
		pop		al
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Select the Applicationcodepage in the Flashmemory for the CS49330
;* al = Flashprogram (0-15 = Program)
;***************************************************************************
;*
Select_CS49330_FlashProgram:
		push	al
		push	ah

		andi	al, 0x0F				; clear upper 4 bits
		swap	al

		lds		ah, PORTF
		andi	ah, 0x0F				; clear upper 4 bits
		or		ah, al
		sts		PORTF, ah

Select_CS49330_Flash_DONE:
		pop		ah
		pop		al
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Select which DSP serial port is connected to the codec
;* return	al = Mode
;* 		1 - CS49326
;* 		2 - CS49330
;* 		3 - External DSP
;***************************************************************************
;*
SelectActiveDSP:
		push	ah
		push	bl

		cpi		al, 1
		breq	SelectActiveDSP_CS49326
		cpi		al, 2
		breq	SelectActiveDSP_CS49330
		cpi		al, 3
		breq	SelectActiveDSP_EXT
		rjmp	SelectActiveDSP_DONE

SelectActiveDSP_CS49326:
		in		al, PORTE
		andi	al, ~((1<<DSPAudioSel)|(1<<ExtDSPAudioSel))
		out 	PORTE, al
		rjmp	SelectActiveDSP_DONE

SelectActiveDSP_CS49330:
		in		al, PORTE
		andi	al, ~(1<<ExtDSPAudioSel)
		ori		al, (1<<DSPAudioSel)
		out 	PORTE, al
		rjmp	SelectActiveDSP_DONE

SelectActiveDSP_EXT:
		in		al, PORTE
		ori		al, (1<<ExtDSPAudioSel)
		out 	PORTE, al
		rjmp	SelectActiveDSP_DONE

SelectActiveDSP_DONE:
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Write a Byte to Codec
;* in:	bl = Address
;* 		al = Byte to write
;* out: none
;***************************************************************************
;*
Write_CODEC_BYTE:
		push	al

		in		al, PORTA
		andi	al, ~(1<<CODEC_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, CODEC_HW_ADR | CODEC_WRITE
		call	SPI_MasterTransmit
		mov		al, bl
		call	SPI_MasterTransmit
		pop		al
		call	SPI_MasterTransmit

		in		al, PORTA
		ori		al, (1<<CODEC_CS)
		out 	PORTA, al

		ldi		cl, 1
		call	WaitDelay
		ret	
;*
;***************************************************************************
	

;***************************************************************************
;* Read a Byte from Codec
;* in:	bl = Address
;* out: al = readed Byte
;***************************************************************************
;*
Read_CODEC_BYTE:
		in		al, PORTA
		andi	al, ~(1<<CODEC_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, CODEC_HW_ADR 
		call	SPI_MasterTransmit
		mov		al, bl
		call	SPI_MasterTransmit

		in		cl, PORTA
		ori		cl, (1<<CODEC_CS)
		out 	PORTA, cl

		in		al, PORTA
		andi	al, ~(1<<CODEC_CS)
		out 	PORTA, al 

		ldi		al, CODEC_HW_ADR | CODEC_READ
		call	SPI_MasterTransmit
		call	SPI_MasterReceive

		in		cl, PORTA
		ori		cl, (1<<CODEC_CS)
		out 	PORTA, cl

		ldi		cl, 5
		call	WaitDelay
		ret
;*
;***************************************************************************


;***************************************************************************
;* 
;***************************************************************************
;*
Reset_CODEC:
		in		al, PORTA
		andi	al, ~(1<<CODEC_RESET)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		in		al, PORTA
		ori		al, (1<<CODEC_RESET)
		out 	PORTA, al

		ldi		cl, 3
		call	WaitDelay
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Write a Byte to Codec
;* in:	bl = Address
;* 		al = Byte to write
;* out: none
;***************************************************************************
;*
Write_SPDIF_TX_BYTE:
		push	bl
		push	cl

		push	al

		in		al, PORTA
		andi	al, ~(1<<SPDIF_TX_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, SPDIF_TX_HW_ADR | SPDIF_TX_WRITE
		call	SPI_MasterTransmit
		mov		al, bl
		call	SPI_MasterTransmit
		pop		al
		call	SPI_MasterTransmit

		in		al, PORTA
		ori		al, (1<<SPDIF_TX_CS)
		out 	PORTA, al

		ldi		cl, 1
		call	WaitDelay

		pop		cl
		pop		bl
		ret	
;*
;***************************************************************************
	

;***************************************************************************
;* Read a Byte from Codec
;* in:	bl = Address
;* out: al = readed Byte
;***************************************************************************
;*
Read_SPDIF_TX_BYTE:
		push	bl
		push	cl

		in		al, PORTA
		andi	al, ~(1<<SPDIF_TX_CS)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		ldi		al, SPDIF_TX_HW_ADR 
		call	SPI_MasterTransmit
		mov		al, bl
		call	SPI_MasterTransmit

		in		cl, PORTA
		ori		cl, (1<<SPDIF_TX_CS)
		out 	PORTA, cl

		in		al, PORTA
		andi	al, ~(1<<SPDIF_TX_CS)
		out 	PORTA, al 

		ldi		al, SPDIF_TX_HW_ADR | SPDIF_TX_READ
		call	SPI_MasterTransmit
		call	SPI_MasterReceive

		in		cl, PORTA
		ori		cl, (1<<SPDIF_TX_CS)
		out 	PORTA, cl

		ldi		cl, 5
		call	WaitDelay

		pop		cl
		pop		bl
		ret
;*
;***************************************************************************


;***************************************************************************
;* 
;***************************************************************************
;*
Reset_SPDIF_TX:
		in		al, PORTA
		andi	al, ~(1<<SPDIF_TX_RESET)
		out 	PORTA, al 

		ldi		cl, 1
		call	WaitDelay

		in		al, PORTA
		ori		al, (1<<SPDIF_TX_RESET)
		out 	PORTA, al

		ldi		cl, 3
		call	WaitDelay
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get the input mode for the board
;* return	al = Mode
;* 		Default = 0
;* 		0 - Digital input
;* 		1 - Analog input
;***************************************************************************
;*
GetBoardInputMode:
		push	ah
		push	bl

		ldi		al, 0
		lds		ah, CS42528Flags_FuncMode
		andi	ah, COD_FL__FuncMode__ADC_SP_SEL0
		brne	GetBoardInputMode_DONE

		ldi		al, 1

GetBoardInputMode_DONE:
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the input mode for the board
;* al = Mode
;* 		Default = 0
;* 		0 - Digital input
;* 		1 - Analog input
;***************************************************************************
;*
SetBoardInputMode:
		push	ah
		push	bl

		cpi		al, 0
		breq	SetBoardInputMode_DIG
		cpi		al, 1
		breq	SetBoardInputMode_ANA
		rjmp	SetMute_ALL_DONE

SetBoardInputMode_DIG:
		lds		al, CS42528Flags_FuncMode
		andi	al, ~COD_FL__FuncMode__ADC_SP_SEL1
		ori		al, COD_FL__FuncMode__ADC_SP_SEL0
		sts		CS42528Flags_FuncMode, al
		ldi		bl, CODEC_ADR_FunctionalMode
		call	Write_CODEC_BYTE
		rjmp	SetBoardInputMode_DONE

SetBoardInputMode_ANA:
		lds		al, CS42528Flags_FuncMode
		andi	al, ~COD_FL__FuncMode__ADC_SP_SEL0
		ori		al, COD_FL__FuncMode__ADC_SP_SEL1
		sts		CS42528Flags_FuncMode, al
		ldi		bl, CODEC_ADR_FunctionalMode
		call	Write_CODEC_BYTE

SetBoardInputMode_DONE:
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume transition mode
;* return	al = Mode
;* 					Default = 0
;* 					0 - Immediate Change
;* 					1 - Zero Cross
;* 					2 - Soft Ramp
;* 					3 - Soft Ramp on Zero Crossings
;***************************************************************************
;*
GetVolumeTransition:
		push	bl

		ldi		bl, CODEC_ADR_VolumeControl
		rcall	Read_CODEC_BYTE
		swap	al
		andi	al, 3

GetVolumeTransition_DONE:
		pop		bl
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume transition mode
;* al = Mode
;* 		Default = 0
;* 		0 - Immediate Change
;* 		1 - Zero Cross
;* 		2 - Soft Ramp
;* 		3 - Soft Ramp on Zero Crossings
;***************************************************************************
;*
SetVolumeTransition:
		push	ah
		push	bl

		mov		ah, al
		andi	ah, 3						; clear all not required bits
		swap	ah							; swap mode bits to correct position [Bits 4:5]

		push	ah
		ldi		bl, CODEC_ADR_VolumeControl
		rcall	Read_CODEC_BYTE
		pop		ah
		or		al, ah
		ldi		bl, CODEC_ADR_VolumeControl
		call	Write_CODEC_BYTE

SetVolumeTransition_DONE:
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of total volume of all channels
;* return	al = Mutestate (0 = off, 1 = Mastermute DSP-Board on)
;***************************************************************************
;*
GetMute_ALL:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_MUTEC
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__MUTEC__MUTE
		brne	GetMute_ALL_DONE

		ldi		ah, 0

GetMute_ALL_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes total volume of all channels
;* al = Mutestate (0 = off, 1 = Mastermute DSP-Board on)
;***************************************************************************
;*
SetMute_ALL:
		cpi		al, 0
		breq	SetMute_ALL_OFF
		cpi		al, 1
		breq	SetMute_ALL_ON
		rjmp	SetMute_ALL_DONE

SetMute_ALL_ON:
		ldi		al, COD_FL__MUTEC__MUTE
		ldi		bl, CODEC_ADR_MUTEC
		rcall	Write_CODEC_BYTE

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		cpi		al, 0xFF
		breq	SetMute_ALL_DONE

		sts		INDPT_CHANNEL_MUTE, al

		ldi		al, 0xFF
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE
		rjmp	SetMute_ALL_DONE

SetMute_ALL_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

		ldi		al, 0
		ldi		bl, CODEC_ADR_MUTEC
		rcall	Write_CODEC_BYTE

SetMute_ALL_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of left channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_LEFT:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_A1_MUTE
		brne	GetMute_LEFT_DONE

		ldi		ah, 0

GetMute_LEFT_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the left channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_LEFT:
		cpi		al, 0
		breq	SetMute_LEFT_OFF
		cpi		al, 1
		breq	SetMute_LEFT_ON
		rjmp	SetMute_LEFT_DONE

SetMute_LEFT_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_A1_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_LEFT_OK

SetMute_LEFT_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_A1_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_LEFT_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_LEFT_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of right channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_RIGHT:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_B1_MUTE
		brne	GetMute_RIGHT_DONE

		ldi		ah, 0

GetMute_RIGHT_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the right channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_RIGHT:
		cpi		al, 0
		breq	SetMute_RIGHT_OFF
		cpi		al, 1
		breq	SetMute_RIGHT_ON
		rjmp	SetMute_RIGHT_DONE

SetMute_RIGHT_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_B1_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_RIGHT_OK

SetMute_RIGHT_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_B1_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_RIGHT_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_RIGHT_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of center channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_CENTER:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_A2_MUTE
		brne	GetMute_CENTER_DONE

		ldi		ah, 0

GetMute_CENTER_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the center channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_CENTER:
		cpi		al, 0
		breq	SetMute_CENTER_OFF
		cpi		al, 1
		breq	SetMute_CENTER_ON
		rjmp	SetMute_CENTER_DONE

SetMute_CENTER_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_A2_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_CENTER_OK

SetMute_CENTER_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_A2_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_CENTER_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_CENTER_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of subwoofer channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_SUBWOOFER:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_B2_MUTE
		brne	GetMute_SUBWOOFER_DONE

		ldi		ah, 0

GetMute_SUBWOOFER_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the subwoofer channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_SUBWOOFER:
		cpi		al, 0
		breq	SetMute_SUBWOOFER_OFF
		cpi		al, 1
		breq	SetMute_SUBWOOFER_ON
		rjmp	SetMute_SUBWOOFER_DONE

SetMute_SUBWOOFER_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_B2_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_SUBWOOFER_OK

SetMute_SUBWOOFER_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_B2_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_SUBWOOFER_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_SUBWOOFER_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of left surround channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_LEFT_SURR:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_A3_MUTE
		brne	GetMute_LEFT_SURR_DONE

		ldi		ah, 0

GetMute_LEFT_SURR_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the left channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_LEFT_SURR:
		cpi		al, 0
		breq	SetMute_LEFT_SURR_OFF
		cpi		al, 1
		breq	SetMute_LEFT_SURR_ON
		rjmp	SetMute_LEFT_SURR_DONE

SetMute_LEFT_SURR_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_A3_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_LEFT_SURR_OK

SetMute_LEFT_SURR_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_A3_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_LEFT_SURR_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_LEFT_SURR_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of right surround channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_RIGHT_SURR:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_B3_MUTE
		brne	GetMute_RIGHT_SURR_DONE

		ldi		ah, 0

GetMute_RIGHT_SURR_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the right surround channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_RIGHT_SURR:
		cpi		al, 0
		breq	SetMute_RIGHT_SURR_OFF
		cpi		al, 1
		breq	SetMute_RIGHT_SURR_ON
		rjmp	SetMute_RIGHT_SURR_DONE

SetMute_RIGHT_SURR_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_B3_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_RIGHT_SURR_OK

SetMute_RIGHT_SURR_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_B3_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_RIGHT_SURR_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_RIGHT_SURR_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of left zone channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_LEFT_ZONE:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_A4_MUTE
		brne	GetMute_LEFT_ZONE_DONE

		ldi		ah, 0

GetMute_LEFT_ZONE_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the left zone channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_LEFT_ZONE:
		cpi		al, 0
		breq	SetMute_LEFT_ZONE_OFF
		cpi		al, 1
		breq	SetMute_LEFT_ZONE_ON
		rjmp	SetMute_LEFT_ZONE_DONE

SetMute_LEFT_ZONE_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_A4_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_LEFT_ZONE_OK

SetMute_LEFT_ZONE_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_A4_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_LEFT_ZONE_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_LEFT_ZONE_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get Mutestate of right zone channel
;* return	al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
GetMute_RIGHT_ZONE:		
		push	ah
		push	bl

		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Read_CODEC_BYTE

		ldi		ah, 1
		andi	al, COD_FL__ChannelMute_B4_MUTE
		brne	GetMute_RIGHT_ZONE_DONE

		ldi		ah, 0

GetMute_RIGHT_ZONE_DONE:
		mov		al, ah
		pop		bl
		pop		ah
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Mutes the right zone channel
;* al = Mutestate (0 = off, 1 = muted)
;***************************************************************************
;*
SetMute_RIGHT_ZONE:
		cpi		al, 0
		breq	SetMute_RIGHT_ZONE_OFF
		cpi		al, 1
		breq	SetMute_RIGHT_ZONE_ON
		rjmp	SetMute_RIGHT_ZONE_DONE

SetMute_RIGHT_ZONE_ON:
		lds		al, INDPT_CHANNEL_MUTE
		ori		al, COD_FL__ChannelMute_B4_MUTE
		sts		INDPT_CHANNEL_MUTE, al
		rjmp	SetMute_RIGHT_ZONE_OK

SetMute_RIGHT_ZONE_OFF:
		lds		al, INDPT_CHANNEL_MUTE
		andi	al, ~COD_FL__ChannelMute_B4_MUTE
		sts		INDPT_CHANNEL_MUTE, al

SetMute_RIGHT_ZONE_OK:
		ldi		bl, CODEC_ADR_ChannelMute
		rcall	Write_CODEC_BYTE

SetMute_RIGHT_ZONE_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get the current SPDIF-Output muting state  
;* return	al = Output (0 = off, 1 = mute active)
;***************************************************************************
;*
GetMute_SPDIF:
		push	bl

		ldi		bl, SPDIF_TX_ADR_Control1
		rcall	Read_SPDIF_TX_BYTE
		swap	al						; Bring bit in the correct position
		andi	al, 1					; clear all other bits

GetSPDIF_Mute_DONE:
		pop		bl
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the current SPDIF-Output muting state  
;* 		al = Output (0 = off, 1 = mute active
;***************************************************************************
;*
SetMute_SPDIF:
		push	bl

		cpi		al, 0
		breq	SetSPDIF_Mute_OFF
		cpi		al, 1
		breq	SetSPDIF_Mute_ON
		rjmp	SetSPDIF_Mute_DONE

SetSPDIF_Mute_OFF:
		ldi		bl, SPDIF_TX_ADR_Control1
		rcall	Read_SPDIF_TX_BYTE
		andi	al, ~SPDIF_FL__MUTEAES
		rcall	Write_SPDIF_TX_BYTE
		rjmp	SetSPDIF_Mute_DONE

SetSPDIF_Mute_ON:
		ldi		bl, SPDIF_TX_ADR_Control1
		rcall	Read_SPDIF_TX_BYTE
		ori		al, SPDIF_FL__MUTEAES
		rcall	Write_SPDIF_TX_BYTE

SetSPDIF_Mute_DONE:
		pop		bl
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the total volume of all channels
;* return	al = Volume
;***************************************************************************
;*
GetVolume_TOTAL:
		lds		al, VOLUME_TOTAL

GetVolume_TOTAL_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the total volume of all channels
;* return	al = Volume
;***************************************************************************
;*
SetVolume_TOTAL:
; Set FREZZE bit 
		push	al
		ldi		bl, CODEC_ADR_MiscControl
		rcall	Read_CODEC_BYTE
		mov		ah, al
		ori		al, COD_FL__MiscControl_FREEZE
		ldi		bl, CODEC_ADR_MiscControl
		rcall	Write_CODEC_BYTE
		pop		al
		push	ah

; Change volume on all channels
		sts		VOLUME_TOTAL, al
		lds		al, VOLUME_LEFT
		call	SetVolume_LEFT
		lds		al, VOLUME_RIGHT
		call	SetVolume_RIGHT
		lds		al, VOLUME_CENTER
		call	SetVolume_CENTER
		lds		al, VOLUME_SUBWOFER
		call	SetVolume_SUBWOOFER
		lds		al, VOLUME_LEFT_SURR
		call	SetVolume_LEFT_SURR
		lds		al, VOLUME_RIGHT_SURR
		call	SetVolume_RIGHT_SURR
		lds		al, VOLUME_LEFT_ZONE
		call	SetVolume_LEFT_ZONE
		lds		al, VOLUME_RIGHT_ZONE
		call	SetVolume_RIGHT_ZONE

; Clear FREZZE bit 
		pop		al
		ldi		bl, CODEC_ADR_MiscControl
		rcall	Write_CODEC_BYTE

SetVolume_TOTAL_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of left channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_LEFT:
		lds		al, VOLUME_LEFT

GetVolume_LEFT_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of left channel
;* al = Volume
;***************************************************************************
;*
SetVolume_LEFT:
		sts		VOLUME_LEFT, al
		cpi		al, 255
		breq	SetVolume_LEFT_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_LEFT_MUTE

		add		al, ah
		brcc	SetVolume_LEFT_OK

SetVolume_LEFT_MUTE:
		ldi		al, 255

SetVolume_LEFT_OK:
		ldi		bl, CODEC_ADR_VolControlA1
		call	Write_CODEC_BYTE

SetVolume_LEFT_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of right channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_RIGHT:
		lds		al, VOLUME_RIGHT

GetVolume_RIGHT_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of right channel
;* al = Volume
;***************************************************************************
;*
SetVolume_RIGHT:
		sts		VOLUME_RIGHT, al
		cpi		al, 255
		breq	SetVolume_RIGHT_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_RIGHT_MUTE

		add		al, ah
		brcc	SetVolume_RIGHT_OK

SetVolume_RIGHT_MUTE:
		ldi		al, 255

SetVolume_RIGHT_OK:
		ldi		bl, CODEC_ADR_VolControlB1
		call	Write_CODEC_BYTE

SetVolume_RIGHT_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of center channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_CENTER:
		lds		al, VOLUME_CENTER

GetVolume_CENTER_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of center channel
;* al = Volume
;***************************************************************************
;*
SetVolume_CENTER:
		sts		VOLUME_CENTER, al
		cpi		al, 255
		breq	SetVolume_CENTER_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_CENTER_MUTE

		add		al, ah
		brcc	SetVolume_CENTER_OK

SetVolume_CENTER_MUTE:
		ldi		al, 255

SetVolume_CENTER_OK:
		ldi		bl, CODEC_ADR_VolControlA2
		call	Write_CODEC_BYTE

SetVolume_CENTER_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of subwoofer channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_SUBWOOFER:
		lds		al, VOLUME_SUBWOFER

GetVolume_SUBWOOFER_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of subwoofer channel
;* al = Volume
;***************************************************************************
;*
SetVolume_SUBWOOFER:
		sts		VOLUME_SUBWOFER, al
		cpi		al, 255
		breq	SetVolume_SUBWOOFER_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_SUBWOOFER_MUTE

		add		al, ah
		brcc	SetVolume_SUBWOOFER_OK

SetVolume_SUBWOOFER_MUTE:
		ldi		al, 255

SetVolume_SUBWOOFER_OK:
		ldi		bl, CODEC_ADR_VolControlB2
		call	Write_CODEC_BYTE

SetVolume_SUBWOOFER_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of left surround channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_LEFT_SURR:
		lds		al, VOLUME_LEFT_SURR

GetVolume_LEFT_SURR_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of left surround channel
;* al = Volume
;***************************************************************************
;*
SetVolume_LEFT_SURR:
		sts		VOLUME_LEFT_SURR, al
		cpi		al, 255
		breq	SetVolume_LEFT_SURR_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_LEFT_SURR_MUTE

		add		al, ah
		brcc	SetVolume_LEFT_SURR_OK

SetVolume_LEFT_SURR_MUTE:
		ldi		al, 255

SetVolume_LEFT_SURR_OK:
		ldi		bl, CODEC_ADR_VolControlA3
		call	Write_CODEC_BYTE

SetVolume_LEFT_SURR_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of right surround channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_RIGHT_SURR:
		lds		al, VOLUME_RIGHT_SURR

GetVolume_RIGHT_SURR_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of right surround channel
;* al = Volume
;***************************************************************************
;*
SetVolume_RIGHT_SURR:
		sts		VOLUME_RIGHT_SURR, al
		cpi		al, 255
		breq	SetVolume_RIGHT_SURR_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_RIGHT_SURR_MUTE

		add		al, ah
		brcc	SetVolume_RIGHT_SURR_OK

SetVolume_RIGHT_SURR_MUTE:
		ldi		al, 255

SetVolume_RIGHT_SURR_OK:
		ldi		bl, CODEC_ADR_VolControlB3
		call	Write_CODEC_BYTE

SetVolume_RIGHT_SURR_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of left zone channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_LEFT_ZONE:
		lds		al, VOLUME_LEFT_ZONE

GetVolume_LEFT_ZONE_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of left zone channel
;* al = Volume
;***************************************************************************
;*
SetVolume_LEFT_ZONE:
		sts		VOLUME_LEFT_ZONE, al
		cpi		al, 255
		breq	SetVolume_LEFT_ZONE_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_LEFT_ZONE_MUTE

		add		al, ah
		brcc	SetVolume_LEFT_ZONE_OK

SetVolume_LEFT_ZONE_MUTE:
		ldi		al, 255

SetVolume_LEFT_ZONE_OK:
		ldi		bl, CODEC_ADR_VolControlA4
		call	Write_CODEC_BYTE

SetVolume_LEFT_ZONE_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Returns the volume of right zone channel
;* return	al = Volume
;***************************************************************************
;*
GetVolume_RIGHT_ZONE:
		lds		al, VOLUME_RIGHT_ZONE

GetVolume_RIGHT_ZONE_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Set the volume of right zone channel
;* al = Volume
;***************************************************************************
;*
SetVolume_RIGHT_ZONE:
		sts		VOLUME_RIGHT_ZONE, al
		cpi		al, 255
		breq	SetVolume_RIGHT_ZONE_MUTE

		lds		ah, VOLUME_TOTAL
		cpi		ah, 255
		breq	SetVolume_RIGHT_ZONE_MUTE

		add		al, ah
		brcc	SetVolume_RIGHT_ZONE_OK

SetVolume_RIGHT_ZONE_MUTE:
		ldi		al, 255

SetVolume_RIGHT_ZONE_OK:
		ldi		bl, CODEC_ADR_VolControlB4
		call	Write_CODEC_BYTE

SetVolume_RIGHT_ZONE_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get the current SPDIF-Input source
;* return	al = Input (0 = off, 1-8 = inputs)
;***************************************************************************
;*
GetSPDIF_Input:
		lds		al, SPDIF_INPUT_SOURCE

GetSPDIF_Input_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Sets the current SPDIF-Input
;* al = Input (0 = off, 1-8 = inputs)
;***************************************************************************
;*
SetSPDIF_Input:
		cpi		al, 0
		breq	SetSPDIF_Input_OFF
		cpi		al, 1
		breq	SetSPDIF_Input_REAR1
		cpi		al, 2
		breq	SetSPDIF_Input_REAR2
		cpi		al, 3
		breq	SetSPDIF_Input_REAR3
		cpi		al, 4
		breq	SetSPDIF_Input_REAR4
		cpi		al, 5
		breq	SetSPDIF_Input_REAR5
		cpi		al, 6
		breq	SetSPDIF_Input_REAR6
		cpi		al, 7
		breq	SetSPDIF_Input_FRONT
		cpi		al, 8
		breq	SetSPDIF_Input_INTERNAL
		rjmp	SetSPDIF_Input_DONE

SetSPDIF_Input_REAR1:
		ldi		ah, 7
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_REAR2:
		ldi		ah, 6
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_REAR3:
		ldi		ah, 5
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_REAR4:
		ldi		ah, 4
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_REAR5:
		ldi		ah, 3
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_REAR6:
		ldi		ah, 2
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_INTERNAL:
		ldi		ah, 0
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_FRONT:
		ldi		ah, 1
		rjmp	SetSPDIF_Input_ON

SetSPDIF_Input_OFF:
		sts		SPDIF_INPUT_SOURCE, al
; Powerdown receiver
		lds		al, CS42528Flags_PowerControl
		ori		al, COD_FL__PDN_RCVR
		sts		CS42528Flags_PowerControl, al
		ldi		bl, CODEC_ADR_PowerControl
		rcall	Write_CODEC_BYTE

; Set Input to default
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Read_CODEC_BYTE
		andi	al, 0xF0
		rcall	Write_CODEC_BYTE
		rjmp	SetSPDIF_Input_DONE

SetSPDIF_Input_ON:
		sts		SPDIF_INPUT_SOURCE, al
		lds		al, CS42528Flags_PowerControl
		andi	al, COD_FL__PDN_RCVR1
		breq	SetSPDIF_Input_SPDIF_ON

SetSPDIF_Input_SPDIF_OFF:
; Enable SPDIF-Receiver if disabled
		push	ah
		lds		al, CS42528Flags_PowerControl
		andi	al, ~COD_FL__PDN_RCVR
		sts		CS42528Flags_PowerControl, al
		ldi		bl, CODEC_ADR_PowerControl
		rcall	Write_CODEC_BYTE
		pop		ah

SetSPDIF_Input_SPDIF_ON:
; Set SPDIF-Receiver input
		push	ah
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Read_CODEC_BYTE
		pop		ah
		andi	al, 0xF0
		or		al, ah
		ldi		bl, CODEC_ADR_PowerControl
		rcall	Write_CODEC_BYTE

SetSPDIF_Input_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Get the current SPDIF-Output source
;* return	al = Output (0 = off, 1-8 = outputs directly driven from inputs, 
;*			  	 9 = output driven from DSP)
;***************************************************************************
;*
GetSPDIF_Output:
		lds		al, SPDIF_OUTPUT_SOURCE

GetSPDIF_Output_DONE:
		ret 
;*
;***************************************************************************


;***************************************************************************
;* Sets the current SPDIF-Output source
;* al = Output (0 = off, 1-8 = outputs directly driven from inputs, 
;*		9 = output driven from DSP)
;***************************************************************************
;*
SetSPDIF_Output:
		cpi		al, 0
		breq	SetSPDIF_Output_OFF
		cpi		al, 1
		breq	SetSPDIF_Output_REAR1
		cpi		al, 2
		breq	SetSPDIF_Output_REAR2
		cpi		al, 3
		breq	SetSPDIF_Output_REAR3
		cpi		al, 4
		breq	SetSPDIF_Output_REAR4
		cpi		al, 5
		breq	SetSPDIF_Output_REAR5
		cpi		al, 6
		breq	SetSPDIF_Output_REAR6
		cpi		al, 7
		breq	SetSPDIF_Output_FRONT
		cpi		al, 8
		breq	SetSPDIF_Output_INTERNAL
		cpi		al, 9
		breq	SetSPDIF_Output_DSP
		rjmp	SetSPDIF_Output_DONE

SetSPDIF_Output_REAR1:
		ldi		ah, 7
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_REAR2:
		ldi		ah, 6
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_REAR3:
		ldi		ah, 5
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_REAR4:
		ldi		ah, 4
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_REAR5:
		ldi		ah, 3
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_REAR6:
		ldi		ah, 2
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_INTERNAL:
		ldi		ah, 0
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_FRONT:
		ldi		ah, 1
		rjmp	SetSPDIF_Output_ON

SetSPDIF_Output_DSP:
		sts		SPDIF_OUTPUT_SOURCE, al
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Read_CODEC_BYTE
		andi	al, 0x0F
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Write_CODEC_BYTE

		ldi		al, 0
		ldi		bl, SPDIF_TX_ADR_DataFlowCtrl
		rcall	Write_SPDIF_TX_BYTE
		rjmp	SetSPDIF_Output_DONE

SetSPDIF_Output_OFF:
		sts		SPDIF_OUTPUT_SOURCE, al
; Powerdown transmitter
		ldi		al, SPDIF_FL__TXOFF
		ldi		bl, SPDIF_TX_ADR_DataFlowCtrl
		rcall	Write_SPDIF_TX_BYTE

; Set Output to default (PC)
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Read_CODEC_BYTE
		andi	al, 0x0F
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Write_CODEC_BYTE
		rjmp	SetSPDIF_Output_DONE

SetSPDIF_Output_ON:
		sts		SPDIF_OUTPUT_SOURCE, al
; Set SPDIF-Receiver Output
		push	ah
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Read_CODEC_BYTE
		pop		ah
		swap	ah
		andi	al, 0xF0
		or		al, ah
		ldi		bl, CODEC_ADR_RCVRModeCtrl2
		rcall	Write_CODEC_BYTE

		ldi		al, SPDIF_FL__AESBP
		ldi		bl, SPDIF_TX_ADR_DataFlowCtrl
		rcall	Write_SPDIF_TX_BYTE

SetSPDIF_Output_DONE:
		ret 
;*
;***************************************************************************


